# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk; Mdk; end
module Mdk
require "datawire-quark-core"
require_relative 'quark/reflect' # 0 ('quark',) ()
require_relative 'mdk_runtime' # 0 () ()
require_relative 'mdk_protocol' # 0 () ()
require_relative 'mdk_discovery' # 0 () ()
require_relative 'quark' # 0 () ()
require_relative 'mdk_tracing' # 0 () ()
require_relative 'mdk_metrics' # 0 () ()
require_relative 'quark/concurrent' # 0 ('quark',) ()
require_relative 'mdk_introspection' # 0 () ()
require_relative 'mdk_discovery/protocol' # 0 ('mdk_discovery',) ()
require_relative 'mdk_discovery/synapse' # 0 ('mdk_discovery',) ()
require_relative 'mdk_rtp' # 0 () ()
require_relative 'mdk_tracing/protocol' # 0 ('mdk_tracing',) ()
require_relative 'mdk_runtime/promise' # 0 ('mdk_runtime',) ()
require_relative 'mdk_util' # 0 () ()


def self._get(env, name, value)
    
    return env.var(name).orElseGet(value)


    nil
end

##
# Convert 'name' or 'fallback:name' into an Environment.

def self._parseEnvironment(environment)
    
    name = environment
    fallback = ::DatawireQuarkCore.cast(nil) { ::String }
    if ((((environment).index(":") or -1)) != (-(1)))
        fallback = (::DatawireQuarkCore.split(environment, ":"))[0]
        name = (::DatawireQuarkCore.split(environment, ":"))[1]
    end
    result = ::Quark.mdk_protocol.OperationalEnvironment.new()
    (result).name = name
    (result).fallbackName = fallback
    return result


    nil
end

##
# Create an unstarted instance of the MDK.

def self.init()
    
    return ::Quark.mdk.MDKImpl.new(::Quark.mdk_runtime.defaultRuntime())


    nil
end

##
# Create a started instance of the MDK. This is equivalent to
# calling init() followed by start() on the resulting instance.
#

def self.start()
    
    m = ::Quark.mdk.init()
    m.start()
    return m


    nil
end

def self.MDK; MDK; end
##
# The MDK API consists of two interfaces: MDK and Session. The
# MDK interface holds globally scoped APIs and state associated
# with the microservice. The Session interface holds locally
# scoped APIs and state. A Session must be used sequentially.
#
# The MDK instance is responsible for communicating with
# foundational services like discovery and tracing.
#
# There will typically be one MDK instance for the entire
# process, and one instance of the Session object per
# thread/channel/request depending on how the MDK is integrated
# and used within the application framework of choice.
#
# A note on versions: service versions indicate API compatibility, not
# releases of the underlying code. They should be in the form
# MAJOR.MINOR, e.g. '2.11'. Major versions indicates
# incompatibility: '1.0' is incompatible with '2.11'. Minor versions
# indicate backwards compatibility with new features: a client that wants
# version '1.1' can talk to version '1.1' and '1.2' but not to version
# '1.0'.
#

class MDK < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static CONTEXT_HEADER: -> { "X-MDK-Context" }
    static mdk_MDK_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Start the MDK. An MDK instance will not communicate with
    # foundational services unless it is started.
    #

    def start()
        raise NotImplementedError, '`MDK.start` is an abstract method'

        nil
    end

    ##
    # Stop the MDK. When the MDK stops unregisters any service
    # endpoints from the discovery system. This should always
    # be done prior to process exit in order to propogate node
    # shutdowns in realtime rather than waiting for heartbeats
    # to detect node departures.
    #

    def stop()
        raise NotImplementedError, '`MDK.stop` is an abstract method'

        nil
    end

    ##
    # Registers a service endpoint with the discovery
    # system. This can be called at any point, however
    # registered endpoints will not be advertised to the
    # discovery system until the MDK is started.
    #

    def register(service, version, address)
        raise NotImplementedError, '`MDK.register` is an abstract method'

        nil
    end

    ##
    # Set the default timeout for MDK sessions.
    #
    # This is the maximum timeout; if a joined session has a lower
    # timeout that will be used.
    #

    def setDefaultDeadline(seconds)
        raise NotImplementedError, '`MDK.setDefaultDeadline` is an abstract method'

        nil
    end

    ##
    # DEPRECATED, use setDefaultDeadline().

    def setDefaultTimeout(seconds)
        raise NotImplementedError, '`MDK.setDefaultTimeout` is an abstract method'

        nil
    end

    ##
    # Creates a new Session. A Session created in this way will
    # result in a new distributed trace. This should therefore
    # be used primarily by edge services. Intermediary and
    # foundational services should make use of
    # join(encodedContext) in order to preserve distributed
    # traces.
    #

    def session()
        raise NotImplementedError, '`MDK.session` is an abstract method'

        nil
    end

    ##
    # Create a new Session and join it to an existing distributed sesion.
    #
    # This should only ever be done once per an encoded context. That
    # means you should only use it for RPC or similar one-off calls. If
    # you received the encoded context via a broadcast medium (pub/sub,
    # message queues with multiple readers, etc.) you should use
    # childSession() instead.
    #

    def join(encodedContext)
        raise NotImplementedError, '`MDK.join` is an abstract method'

        nil
    end

    ##
    # Create a new Session. The given encoded distributed session's
    # properties will be used to configure the new Session,
    # e.g. overrides will be preserved. However, because this is a new
    # Session the timeout will not be copied from the encoded session.
    #
    # This is intended for use for encoded context received via a
    # broadcast medium (pub/sub, message queues with multiple readers,
    # etc.). If you know only you received the encoded context,
    # e.g. you're coding a server that receives the context from a HTTP
    # request, you should join() instead.
    #

    def derive(encodedContext)
        raise NotImplementedError, '`MDK.derive` is an abstract method'

        nil
    end

    def __init_fields__()
        

        nil
    end


end
MDK.unlazy_statics

def self.Session; Session; end
##
# A session provides a lightweight sequential context that a
# microservice can use in the context of any application
# framework in order to manage its interactions with other
# microservices. It provides simple APIs for service
# resolution, distributed tracing, and circuit breakers.
#
# A microservices architecture enables small self contained
# units of business logic to be implemented by separate teams
# working on isolated services based on the languages and
# frameworks best suited for their problem domain.
#
# Any given microservice will contain sequential business logic
# implemented in a variety of ways depending on the application
# framework chosen. For example it may be a long running
# thread, a simple blocking request handler, or a chained
# series of reactive handlers in an async environment.
#
# For the most part this business logic can be implemented
# exactly as prescribed by the application framework of choice,
# however in a microservices architecture, some special care
# needs to be taken when this business logic interacts with
# other microservices.
#
# Because microservices are updated with much higher frequency
# than normal web applications, the interactions between them
# form key points that require extra care beyond normal web
# interactions in order to avoid creating a system that is both
# extremely fragile, unreliable, and opaque.
#
# Realtime service resolution, distributed tracing, and
# resilience heuristics such as circuit breakers provide the
# foundational behavior required at these interaction
# points. These capabilites must be combined with the defensive
# coding practice of intelligent fallback behavior when remote
# services are unavailable or misbehaving, in order to build a
# robust microservice application.
#
# Because of this, a session is expected to be created and made
# available to all business logic within a given microservice,
# e.g. on a per request basis, as a thread local, part of a
# context object, etc depending on the application framework of
# choice.
#

class Session < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_Session_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Grabs the encoded context.

    def inject()
        raise NotImplementedError, '`Session.inject` is an abstract method'

        nil
    end

    ##
    # Returns an externalized representation of the distributed session.

    def externalize()
        raise NotImplementedError, '`Session.externalize` is an abstract method'

        nil
    end

    ##
    # Record a log entry at the CRITICAL logging level.

    def critical(category, text)
        raise NotImplementedError, '`Session.critical` is an abstract method'

        nil
    end

    ##
    # Record a log entry at the ERROR logging level.

    def error(category, text)
        raise NotImplementedError, '`Session.error` is an abstract method'

        nil
    end

    ##
    # Record a log entry at the WARN logging level.

    def warn(category, text)
        raise NotImplementedError, '`Session.warn` is an abstract method'

        nil
    end

    ##
    # Record a log entry at the INFO logging level.

    def info(category, text)
        raise NotImplementedError, '`Session.info` is an abstract method'

        nil
    end

    ##
    # Record a log entry at the DEBUG logging level.

    def debug(category, text)
        raise NotImplementedError, '`Session.debug` is an abstract method'

        nil
    end

    ##
    # EXPERIMENTAL: Set the logging level for the session.

    def trace(level)
        raise NotImplementedError, '`Session.trace` is an abstract method'

        nil
    end

    ##
    # EXPERIMENTAL; requires MDK_EXPERIMENTAL=1 environment variable to
    # function.
    #
    # Override service resolution for the current distributed
    # session. All attempts to resolve *service*, *version*
    # will be replaced with an attempt to resolve *target*,
    # *targetVersion*. This effect will be propogated to any
    # downstream services involved in the distributed session.
    #

    def route(service, version, target, targetVersion)
        raise NotImplementedError, '`Session.route` is an abstract method'

        nil
    end

    ##
    # Locate a compatible service instance.
    #
    # Uses a minimum of 10 seconds and the timeout set on the session.
    #

    def resolve(service, version)
        raise NotImplementedError, '`Session.resolve` is an abstract method'

        nil
    end

    ##
    # Locate a compatible service instance with a non-default timeout.
    #

    def resolve_until(service, version, timeout)
        raise NotImplementedError, '`Session.resolve_until` is an abstract method'

        nil
    end

    ##
    # Locate a compatible service instance asynchronously. The result is returned as a promise.
    #

    def resolve_async(service, version)
        raise NotImplementedError, '`Session.resolve_async` is an abstract method'

        nil
    end

    ##
    # Start an interaction with a remote service.
    #
    # The session tracks any nodes resolved during an
    # interactin with a remote service.
    #
    # The service resolution API permits a compatible instance
    # of the service to be located. In addition, it tracks
    # which exact instances are in use during any
    # interaction. Should the interaction fail, circuit breaker
    # state is updated for those nodes, and all involved
    # instances involved are reported to the tracing services.
    #
    # This permits realtime reporting of integration issues
    # when services are updated, and also allows circuit
    # breakers to mitigate the impact of any such issues.
    #

    def start_interaction()
        raise NotImplementedError, '`Session.start_interaction` is an abstract method'

        nil
    end

    ##
    # Record an interaction as failed.
    #
    # This will update circuit breaker state for the remote
    # nodes, as well as reporting all nodes involved to the
    # tracing system.
    #

    def fail_interaction(message)
        raise NotImplementedError, '`Session.fail_interaction` is an abstract method'

        nil
    end

    ##
    # Finish an interaction.
    #
    # This marks an interaction as completed.
    #

    def finish_interaction()
        raise NotImplementedError, '`Session.finish_interaction` is an abstract method'

        nil
    end

    ##
    # This is a convenience API that will perform
    # start_interaction() followed by callable(ssn) followed by
    # finish_interaction().
    #
    #

    def interact(callable)
        raise NotImplementedError, '`Session.interact` is an abstract method'

        nil
    end

    ##
    # Set how many seconds the session is expected to live from this point.
    #
    # If a timeout has previously been set the new timeout will only be
    # used if it is lower than the existing timeout.
    #
    # The MDK will not enforce the timeout. Rather, it provides the
    # information to any process or server in the same session (even if
    # they are on different machines). By passing this timeout to
    # blocking APIs you can ensure timeouts are enforced across a whole
    # distributed session.
    #

    def setDeadline(seconds)
        raise NotImplementedError, '`Session.setDeadline` is an abstract method'

        nil
    end

    ##
    # DEPRECATED, use setDeadline().

    def setTimeout(seconds)
        raise NotImplementedError, '`Session.setTimeout` is an abstract method'

        nil
    end

    ##
    # Return how many seconds until the session ought to end.
    #
    # This will only be accurate across multiple servers insofar as their
    # clocks are in sync.
    #
    # If a timeout has not been set the result will be null.
    #

    def getRemainingTime()
        raise NotImplementedError, '`Session.getRemainingTime` is an abstract method'

        nil
    end

    ##
    # Return the value of a property from the distributed session.

    def getProperty(property)
        raise NotImplementedError, '`Session.getProperty` is an abstract method'

        nil
    end

    ##
    # Set a property on the distributed session.
    #
    # The key should be prefixed with a namespace so that it doesn't conflict
    # with built-in properties, e.g. 'examplenamespace:myproperty' instead of
    # 'myproperty'.
    #
    # The value should be JSON serializable.
    #

    def setProperty(property, value)
        raise NotImplementedError, '`Session.setProperty` is an abstract method'

        nil
    end

    ##
    # Return whether the distributed session has a property.

    def hasProperty(property)
        raise NotImplementedError, '`Session.hasProperty` is an abstract method'

        nil
    end

    ##
    # Return the session's Environment.

    def getEnvironment()
        raise NotImplementedError, '`Session.getEnvironment` is an abstract method'

        nil
    end

    def __init_fields__()
        

        nil
    end


end
Session.unlazy_statics

def self.MDKImpl; MDKImpl; end
class MDKImpl < ::DatawireQuarkCore::QuarkObject
    attr_accessor :logger, :_reflection_hack, :_runtime, :_wsclient, :_openclose, :_disco, :_discoSource, :_tracer, :_metrics, :procUUID, :_running, :_defaultTimeout, :_environment
    extend ::DatawireQuarkCore::Static

    static mdk_MDKImpl_ref: -> { nil }
    static quark_Map_quark_String_quark_Object__ref: -> { nil }
    static CONTEXT_HEADER: -> { "X-MDK-Context" }



    def initialize(runtime)
        
        self.__init_fields__
        @_reflection_hack = ::Hash.new()
        @_runtime = runtime
        @_environment = ::Quark.mdk._parseEnvironment(runtime.getEnvVarsService().var("MDK_ENVIRONMENT").orElseGet("sandbox"))
        if (!((runtime).dependencies.hasService("failurepolicy_factory")))
            (runtime).dependencies.registerService("failurepolicy_factory", self.getFailurePolicy(runtime))
        end
        if ((runtime).dependencies.hasService("tracer"))
            @_tracer = ::DatawireQuarkCore.cast((@_runtime).dependencies.getService("tracer")) { ::Quark.mdk_tracing.Tracer }
        end
        @_disco = ::Quark.mdk_discovery.Discovery.new(runtime)
        @_wsclient = self.getWSClient(runtime)
        if ((@_wsclient) != (nil))
            @_openclose = ::Quark.mdk_protocol.OpenCloseSubscriber.new(@_wsclient, @procUUID, @_environment)
        end
        env = runtime.getEnvVarsService()
        discoFactory = self.getDiscoveryFactory(env)
        @_discoSource = discoFactory.create(@_disco, runtime)
        if (discoFactory.isRegistrar())
            (runtime).dependencies.registerService("discovery_registrar", @_discoSource)
        end
        if ((@_wsclient) != (nil))
            if ((@_tracer) == (nil))
                @_tracer = ::Quark.mdk_tracing.Tracer.new(runtime, @_wsclient)
            end
            @_metrics = ::Quark.mdk_metrics.MetricsClient.new(@_wsclient)
        end

        nil
    end




    ##
    # Choose DiscoverySource based on environment variables.

    def getDiscoveryFactory(env)
        
        config = env.var("MDK_DISCOVERY_SOURCE").orElseGet("")
        if ((config) == (""))
            config = ("datawire:") + (::Quark.mdk_introspection.DatawireToken.getToken(env))
        end
        result = ::DatawireQuarkCore.cast(nil) { ::Quark.mdk_discovery.DiscoverySourceFactory }
        if ((config).start_with?("datawire:"))
            result = ::Quark.mdk_discovery.protocol.DiscoClientFactory.new(@_wsclient)
        else
            if ((config).start_with?("synapse:path="))
                result = ::Quark.mdk_discovery.synapse.Synapse.new((config)[(13)...((config).size)], (self)._environment)
            else
                if ((config).start_with?("static:nodes="))
                    json = (config)[(13)...((config).size)]
                    result = ::Quark.mdk_discovery.StaticRoutes.parseJSON(json)
                else
                    raise (("Unknown MDK discovery source: ") + (config))
                end
            end
        end
        return result

        nil
    end

    ##
    # Choose FailurePolicy based on environment variables.

    def getFailurePolicy(runtime)
        
        config = runtime.getEnvVarsService().var("MDK_FAILURE_POLICY").orElseGet("")
        if ((config) == ("recording"))
            return ::Quark.mdk_discovery.RecordingFailurePolicyFactory.new()
        else
            return ::Quark.mdk_discovery.CircuitBreakerFactory.new(runtime)
        end

        nil
    end

    ##
    # Get a WSClient, unless env variables suggest the user doesn't want one.

    def getWSClient(runtime)
        
        env = runtime.getEnvVarsService()
        token = env.var("DATAWIRE_TOKEN").orElseGet("")
        disco_config = env.var("MDK_DISCOVERY_SOURCE").orElseGet("")
        if ((token) == (""))
            if ((disco_config).start_with?("datawire:"))
                token = (disco_config)[(9)...((disco_config).size)]
            else
                return ::DatawireQuarkCore.cast(nil) { ::Quark.mdk_protocol.WSClient }
            end
        end
        ddu = env.var("MDK_SERVER_URL")
        url = ddu.orElseGet("wss://mcp.datawire.io/rtp")
        return ::Quark.mdk_protocol.WSClient.new(runtime, ::Quark.mdk_rtp.getRTPParser(), url, token)

        nil
    end

    def _timeout()
        
        return 10.0

        nil
    end

    def start()
        
        (self)._running = true
        if ((@_wsclient) != (nil))
            (@_runtime).dispatcher.startActor(@_wsclient)
            (@_runtime).dispatcher.startActor(@_openclose)
            (@_runtime).dispatcher.startActor(@_tracer)
            (@_runtime).dispatcher.startActor(@_metrics)
        end
        (@_runtime).dispatcher.startActor(@_disco)
        (@_runtime).dispatcher.startActor(@_discoSource)

        nil
    end

    def stop()
        
        (self)._running = false
        (@_runtime).dispatcher.stopActor(@_discoSource)
        (@_runtime).dispatcher.stopActor(@_disco)
        if ((@_wsclient) != (nil))
            (@_runtime).dispatcher.stopActor(@_tracer)
            (@_runtime).dispatcher.stopActor(@_openclose)
            (@_runtime).dispatcher.stopActor(@_wsclient)
        end
        @_runtime.stop()

        nil
    end

    def register(service, version, address)
        
        node = ::Quark.mdk_discovery.Node.new()
        (node).id = @procUUID
        (node).service = service
        (node).version = version
        (node).address = address
        (node).environment = (self)._environment
        (node).properties = {"datawire_nodeId" => @procUUID}
        @_disco.register(node)

        nil
    end

    def setDefaultDeadline(seconds)
        
        (self)._defaultTimeout = seconds

        nil
    end

    def setDefaultTimeout(seconds)
        
        self.setDefaultDeadline(seconds)

        nil
    end

    def session()
        
        session = ::Quark.mdk.SessionImpl.new(self, nil, (self)._environment)
        if ((@_defaultTimeout) != (nil))
            session.setDeadline(@_defaultTimeout)
        end
        return session

        nil
    end

    def derive(encodedContext)
        
        session = ::DatawireQuarkCore.cast(self.session()) { ::Quark.mdk.SessionImpl }
        parent = ::Quark.mdk_protocol.SharedContext.decode(encodedContext)
        ((session)._context).properties = (parent).properties
        if ((((session)._context).properties).key?("timeout"))
            (((session)._context).properties).delete("timeout")
        end
        session.info("mdk", ((("This session is derived from trace ") + ((parent).traceId)) + (" ")) + ((((parent).clock).clocks).to_s))
        return session

        nil
    end

    def join(encodedContext)
        
        session = ::Quark.mdk.SessionImpl.new(self, encodedContext, (self)._environment)
        if ((@_defaultTimeout) != (nil))
            session.setDeadline(@_defaultTimeout)
        end
        return session

        nil
    end

    def _getClass()
        
        return "mdk.MDKImpl"

        nil
    end

    def _getField(name)
        
        if ((name) == ("CONTEXT_HEADER"))
            return ::Quark.mdk.MDK.CONTEXT_HEADER
        end
        if ((name) == ("logger"))
            return (self).logger
        end
        if ((name) == ("_reflection_hack"))
            return (self)._reflection_hack
        end
        if ((name) == ("_runtime"))
            return (self)._runtime
        end
        if ((name) == ("_wsclient"))
            return (self)._wsclient
        end
        if ((name) == ("_openclose"))
            return (self)._openclose
        end
        if ((name) == ("_disco"))
            return (self)._disco
        end
        if ((name) == ("_discoSource"))
            return (self)._discoSource
        end
        if ((name) == ("_tracer"))
            return (self)._tracer
        end
        if ((name) == ("_metrics"))
            return (self)._metrics
        end
        if ((name) == ("procUUID"))
            return (self).procUUID
        end
        if ((name) == ("_running"))
            return (self)._running
        end
        if ((name) == ("_defaultTimeout"))
            return (self)._defaultTimeout
        end
        if ((name) == ("_environment"))
            return (self)._environment
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("logger"))
            (self).logger = value
        end
        if ((name) == ("_reflection_hack"))
            (self)._reflection_hack = ::DatawireQuarkCore.cast(value) { ::Hash }
        end
        if ((name) == ("_runtime"))
            (self)._runtime = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.MDKRuntime }
        end
        if ((name) == ("_wsclient"))
            (self)._wsclient = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.WSClient }
        end
        if ((name) == ("_openclose"))
            (self)._openclose = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.OpenCloseSubscriber }
        end
        if ((name) == ("_disco"))
            (self)._disco = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_discovery.Discovery }
        end
        if ((name) == ("_discoSource"))
            (self)._discoSource = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_discovery.DiscoverySource }
        end
        if ((name) == ("_tracer"))
            (self)._tracer = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_tracing.Tracer }
        end
        if ((name) == ("_metrics"))
            (self)._metrics = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_metrics.MetricsClient }
        end
        if ((name) == ("procUUID"))
            (self).procUUID = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("_running"))
            (self)._running = ::DatawireQuarkCore.cast(value) { ::Object }
        end
        if ((name) == ("_defaultTimeout"))
            (self)._defaultTimeout = ::DatawireQuarkCore.cast(value) { ::Float }
        end
        if ((name) == ("_environment"))
            (self)._environment = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.OperationalEnvironment }
        end

        nil
    end

    def __init_fields__()
        
        self.logger = ::Quark.quark._getLogger("mdk")
        self._reflection_hack = nil
        self._runtime = nil
        self._wsclient = nil
        self._openclose = nil
        self._disco = nil
        self._discoSource = nil
        self._tracer = nil
        self._metrics = nil
        self.procUUID = ::Quark.quark.concurrent.Context.runtime().uuid()
        self._running = false
        self._defaultTimeout = nil
        self._environment = nil

        nil
    end


end
MDKImpl.unlazy_statics

def self._TLSInit; TLSInit; end
class TLSInit < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk__TLSInit_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    def getValue()
        
        return false

        nil
    end

    def _getClass()
        
        return "mdk._TLSInit"

        nil
    end

    def _getField(name)
        
        return nil

        nil
    end

    def _setField(name, value)
        
        nil

        nil
    end

    def __init_fields__()
        

        nil
    end


end
TLSInit.unlazy_statics

def self.LoggedMessageId; LoggedMessageId; end
##
# Information about the message that was just logged.
#

class LoggedMessageId < ::DatawireQuarkCore::QuarkObject
    attr_accessor :traceId, :causalLevel, :environment, :environmentFallback
    extend ::DatawireQuarkCore::Static

    static mdk_LoggedMessageId_ref: -> { nil }
    static quark_List_quark_int__ref: -> { nil }



    def initialize(traceId, causalLevel, environment, environmentFallback)
        
        self.__init_fields__
        (self).traceId = traceId
        (self).causalLevel = causalLevel
        (self).environment = environment
        (self).environmentFallback = environmentFallback

        nil
    end




    def _getClass()
        
        return "mdk.LoggedMessageId"

        nil
    end

    def _getField(name)
        
        if ((name) == ("traceId"))
            return (self).traceId
        end
        if ((name) == ("causalLevel"))
            return (self).causalLevel
        end
        if ((name) == ("environment"))
            return (self).environment
        end
        if ((name) == ("environmentFallback"))
            return (self).environmentFallback
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("traceId"))
            (self).traceId = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("causalLevel"))
            (self).causalLevel = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end
        if ((name) == ("environment"))
            (self).environment = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("environmentFallback"))
            (self).environmentFallback = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        self.traceId = nil
        self.causalLevel = nil
        self.environment = nil
        self.environmentFallback = nil

        nil
    end


end
LoggedMessageId.unlazy_statics

def self.SessionImpl; SessionImpl; end
class SessionImpl < ::DatawireQuarkCore::QuarkObject
    attr_accessor :_mdk, :_resolved, :_interactionReports, :_context, :_experimental
    extend ::DatawireQuarkCore::Static

    static _levels: -> { {"CRITICAL" => 0, "ERROR" => 1, "WARN" => 2, "INFO" => 3, "DEBUG" => 4} }
    static _inLogging: -> { ::DatawireQuarkCore::TLS.new(::Quark.mdk._TLSInit.new()) }
    static mdk_SessionImpl_ref: -> { nil }
    static quark_List_quark_List_mdk_discovery_Node___ref: -> { nil }
    static quark_List_mdk_discovery_Node__ref: -> { nil }
    static quark_List_mdk_metrics_InteractionEvent__ref: -> { nil }
    static quark_List_quark_Map_quark_String_quark_String___ref: -> { nil }
    static quark_List_quark_String__ref: -> { nil }
    static quark_Map_quark_String_quark_int__ref: -> { nil }
    static quark_Map_quark_String_quark_List_quark_Map_quark_String_quark_String____ref: -> { nil }
    static quark_Map_quark_String_quark_String__ref: -> { nil }



    def initialize(mdk, encodedContext, localEnvironment)
        
        self.__init_fields__
        @_experimental = ((mdk)._runtime.getEnvVarsService().var("MDK_EXPERIMENTAL").orElseGet("")) != ("")
        @_mdk = mdk
        encodedContext = ::DatawireQuarkCore.cast(encodedContext) { ::String }
        if (((encodedContext) == (nil)) || ((encodedContext) == ("")))
            @_context = ::Quark.mdk_protocol.SharedContext.new()
            (@_context).environment = localEnvironment
        else
            ctx = ::Quark.mdk_protocol.SharedContext.decode(encodedContext)
            @_context = ctx.start_span()
        end
        self._start_interaction()

        nil
    end




    def getEnvironment()
        
        return ((self)._context).environment

        nil
    end

    def getProperty(property)
        
        return ((@_context).properties)[property]

        nil
    end

    def setProperty(property, value)
        
        ((@_context).properties)[property] = (value)

        nil
    end

    def hasProperty(property)
        
        return ((@_context).properties).key?(property)

        nil
    end

    def setTimeout(timeout)
        
        self.setDeadline(timeout)

        nil
    end

    def setDeadline(timeout)
        
        current = self.getRemainingTime()
        if ((current) == (nil))
            current = timeout
        end
        if ((timeout) > (current))
            timeout = current
        end
        self.setProperty("timeout", ((@_mdk)._runtime.getTimeService().time()) + (timeout))

        nil
    end

    def getRemainingTime()
        
        deadline = ::DatawireQuarkCore.cast(self.getProperty("timeout")) { ::Float }
        if ((deadline) == (nil))
            return ::DatawireQuarkCore.cast(nil) { ::Float }
        end
        return (deadline) - ((@_mdk)._runtime.getTimeService().time())

        nil
    end

    def route(service, version, target, targetVersion)
        
        routes = nil
        if (!(self.hasProperty("routes")))
            routes = {}
            self.setProperty("routes", routes)
        else
            routes = ::DatawireQuarkCore.cast(self.getProperty("routes")) { ::Hash }
        end
        targets = nil
        if ((routes).key?(service))
            targets = (routes)[service]
        else
            targets = ::DatawireQuarkCore::List.new([])
            (routes)[service] = (targets)
        end
        (targets) << ({"version" => version, "target" => target, "targetVersion" => targetVersion})

        nil
    end

    def trace(level)
        
        self.setProperty("trace", level)

        nil
    end

    def self._level(level)
        
        if ((::Quark.mdk.SessionImpl._levels).key?(level))
            return (::Quark.mdk.SessionImpl._levels)[level]
        else
            return 0
        end

        nil
    end

    def _enabled(level)
        
        ilevel = ::Quark.mdk.SessionImpl._level("INFO")
        if (self.hasProperty("trace"))
            ilevel = ::Quark.mdk.SessionImpl._level(::DatawireQuarkCore.cast(self.getProperty("trace")) { ::String })
        end
        return (::Quark.mdk.SessionImpl._level(level)) <= (ilevel)

        nil
    end

    def _log(level, category, text)
        
        if (::Quark.mdk.SessionImpl._inLogging.getValue())
            return ::DatawireQuarkCore.cast(nil) { ::Quark.mdk.LoggedMessageId }
        end
        ::Quark.mdk.SessionImpl._inLogging.setValue(true)
        evt = ::Quark.mdk_tracing.createLogEvent(@_context, (@_mdk).procUUID, level, category, text)
        if ((((@_mdk)._tracer) != (nil)) && (self._enabled(level)))
            (@_mdk)._tracer.log(evt)
        end
        ::Quark.mdk.SessionImpl._inLogging.setValue(false)
        return ::Quark.mdk.LoggedMessageId.new((@_context).traceId, (((evt).context).clock).clocks, ((@_context).environment).name, ((@_context).environment).fallbackName)

        nil
    end

    def critical(category, text)
        
        return self._log("CRITICAL", category, text)

        nil
    end

    def error(category, text)
        
        return self._log("ERROR", category, text)

        nil
    end

    def warn(category, text)
        
        return self._log("WARN", category, text)

        nil
    end

    def info(category, text)
        
        return self._log("INFO", category, text)

        nil
    end

    def debug(category, text)
        
        return self._log("DEBUG", category, text)

        nil
    end

    def _resolve(service, version)
        
        if (@_experimental)
            routes = ::DatawireQuarkCore.cast(self.getProperty("routes")) { ::Hash }
            if (((routes) != (nil)) && ((routes).key?(service)))
                targets = (routes)[service]
                idx = 0
                while ((idx) < ((targets).size)) do
                    target = (targets)[idx]
                    if (::Quark.mdk_util.versionMatch((target)["version"], version))
                        service = (target)["target"]
                        version = (target)["targetVersion"]
                        break
                    end
                    idx = (idx) + (1)
                end
            end
        end
        return (@_mdk)._disco.resolve(service, version, self.getEnvironment()).andThen(::Quark.quark._BoundMethod.new(self, "_resolvedCallback", ::DatawireQuarkCore::List.new([])))

        nil
    end

    def resolve_async(service, version)
        
        return ::Quark.mdk_util.toNativePromise(self._resolve(service, version))

        nil
    end

    def resolve(service, version)
        
        timeout = @_mdk._timeout()
        session_timeout = self.getRemainingTime()
        if (((session_timeout) != (nil)) && ((session_timeout) < (timeout)))
            timeout = session_timeout
        end
        return self.resolve_until(service, version, timeout)

        nil
    end

    def resolve_until(service, version, timeout)
        
        return ::DatawireQuarkCore.cast(::Quark.mdk_util.WaitForPromise.wait(self._resolve(service, version), timeout, (((("service ") + (service)) + ("(")) + (version)) + (")"))) { ::Quark.mdk_discovery.Node }

        nil
    end

    def _resolvedCallback(result)
        
        (self._current_interaction()) << (result)
        return result

        nil
    end

    def _current_interaction()
        
        return (@_resolved)[((@_resolved).size) - (1)]

        nil
    end

    def start_interaction()
        
        interactionReport = self._start_interaction()
        lmid = self.info("MDK", "Starting interaction.")
        (interactionReport).startClock = (lmid).causalLevel

        nil
    end

    def _start_interaction()
        
        interactionReport = ::Quark.mdk_metrics.InteractionEvent.new()
        (interactionReport).node = (@_mdk).procUUID
        (interactionReport).startTimestamp = ((1000.0) * ((@_mdk)._runtime.getTimeService().time())).round()
        (interactionReport).session = (@_context).traceId
        (interactionReport).environment = (@_context).environment
        (@_interactionReports) << (interactionReport)
        (@_resolved) << (::DatawireQuarkCore::List.new([]))
        return interactionReport

        nil
    end

    def inject()
        
        return self.externalize()

        nil
    end

    def externalize()
        
        result = @_context.encode()
        @_context.tick()
        return result

        nil
    end

    def fail_interaction(message)
        
        suspects = self._current_interaction()
        (@_resolved)[((@_resolved).size) - (1)] = (::DatawireQuarkCore::List.new([]))
        involved = ::DatawireQuarkCore::List.new([])
        idx = 0
        while ((idx) < ((suspects).size)) do
            node = (suspects)[idx]
            idx = (idx) + (1)
            (involved) << (node.toString())
            node.failure()
            (@_interactionReports)[((@_interactionReports).size) - (1)].addNode(node, false)
        end
        text = "no dependent services involved"
        if (((involved).size) > (0))
            text = ("involved: ") + ((involved).join(", "))
        end
        self.error("interaction failure", ((text) + ("\n\n")) + (message))

        nil
    end

    def finish_interaction()
        
        nodes = self._current_interaction()
        (@_resolved).delete_at(((@_resolved).size) - (1))
        report = (@_interactionReports).delete_at(((@_interactionReports).size) - (1))
        (report).endTimestamp = ((1000.0) * ((@_mdk)._runtime.getTimeService().time())).round()
        lmid = self.info("MDK", "Finished interaction.")
        (report).endClock = (lmid).causalLevel
        idx = 0
        while ((idx) < ((nodes).size)) do
            node = (nodes)[idx]
            node.success()
            report.addNode(node, true)
            idx = (idx) + (1)
        end
        if (((@_mdk)._metrics) != (nil))
            (@_mdk)._metrics.sendInteraction(report)
        end

        nil
    end

    def interact(cmd)
        
        self.start_interaction()
        (cmd).call(self)
        self.finish_interaction()

        nil
    end

    def _getClass()
        
        return "mdk.SessionImpl"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_levels"))
            return ::Quark.mdk.SessionImpl._levels
        end
        if ((name) == ("_inLogging"))
            return ::Quark.mdk.SessionImpl._inLogging
        end
        if ((name) == ("_mdk"))
            return (self)._mdk
        end
        if ((name) == ("_resolved"))
            return (self)._resolved
        end
        if ((name) == ("_interactionReports"))
            return (self)._interactionReports
        end
        if ((name) == ("_context"))
            return (self)._context
        end
        if ((name) == ("_experimental"))
            return (self)._experimental
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_levels"))
            ::Quark.mdk.SessionImpl._levels = ::DatawireQuarkCore.cast(value) { ::Hash }
        end
        if ((name) == ("_inLogging"))
            ::Quark.mdk.SessionImpl._inLogging = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::TLS }
        end
        if ((name) == ("_mdk"))
            (self)._mdk = ::DatawireQuarkCore.cast(value) { ::Quark.mdk.MDKImpl }
        end
        if ((name) == ("_resolved"))
            (self)._resolved = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end
        if ((name) == ("_interactionReports"))
            (self)._interactionReports = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end
        if ((name) == ("_context"))
            (self)._context = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.SharedContext }
        end
        if ((name) == ("_experimental"))
            (self)._experimental = ::DatawireQuarkCore.cast(value) { ::Object }
        end

        nil
    end

    def __init_fields__()
        
        self._mdk = nil
        self._resolved = ::DatawireQuarkCore::List.new([])
        self._interactionReports = ::DatawireQuarkCore::List.new([])
        self._context = nil
        self._experimental = false

        nil
    end


end
SessionImpl.unlazy_statics


require_relative 'datawire_mdk_md' # 0 () ()

end # module Mdk
end # module Quark
