# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_metrics; MdkMetrics; end
module MdkMetrics
require "datawire-quark-core"
require_relative 'quark/reflect' # 0 ('quark',) ()
require_relative 'mdk_protocol' # 0 () ()
require_relative 'quark/concurrent' # 0 ('quark',) ()
require_relative 'mdk_discovery' # 0 () ()
require_relative 'mdk_runtime/actors' # 0 ('mdk_runtime',) ()


def self.InteractionEvent; InteractionEvent; end
##
# Wire protocol message for reporting interaction results to MCP.

class InteractionEvent < ::Quark.mdk_protocol.Serializable
    attr_accessor :startTimestamp, :endTimestamp, :environment, :uuid, :session, :node, :results, :startClock, :endClock
    extend ::DatawireQuarkCore::Static

    static _json_type: -> { "interactionevent" }
    static mdk_metrics_InteractionEvent_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def getTimestamp()
        
        return (self).startTimestamp

        nil
    end

    ##
    # Add the result of communicating with a specific node.

    def addNode(destination, success)
        
        value = 0
        if (success)
            value = 1
        end
        ((self).results)[destination.getId()] = (value)

        nil
    end

    def _getClass()
        
        return "mdk_metrics.InteractionEvent"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_json_type"))
            return ::Quark.mdk_metrics.InteractionEvent._json_type
        end
        if ((name) == ("startTimestamp"))
            return (self).startTimestamp
        end
        if ((name) == ("endTimestamp"))
            return (self).endTimestamp
        end
        if ((name) == ("environment"))
            return (self).environment
        end
        if ((name) == ("uuid"))
            return (self).uuid
        end
        if ((name) == ("session"))
            return (self).session
        end
        if ((name) == ("node"))
            return (self).node
        end
        if ((name) == ("results"))
            return (self).results
        end
        if ((name) == ("startClock"))
            return (self).startClock
        end
        if ((name) == ("endClock"))
            return (self).endClock
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_json_type"))
            ::Quark.mdk_metrics.InteractionEvent._json_type = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("startTimestamp"))
            (self).startTimestamp = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("endTimestamp"))
            (self).endTimestamp = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("environment"))
            (self).environment = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.OperationalEnvironment }
        end
        if ((name) == ("uuid"))
            (self).uuid = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("session"))
            (self).session = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("node"))
            (self).node = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("results"))
            (self).results = ::DatawireQuarkCore.cast(value) { ::Hash }
        end
        if ((name) == ("startClock"))
            (self).startClock = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end
        if ((name) == ("endClock"))
            (self).endClock = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.startTimestamp = nil
        self.endTimestamp = nil
        self.environment = nil
        self.uuid = ::Quark.quark.concurrent.Context.runtime().uuid()
        self.session = nil
        self.node = nil
        self.results = {}
        self.startClock = ::DatawireQuarkCore::List.new([])
        self.endClock = ::DatawireQuarkCore::List.new([])

        nil
    end


end
InteractionEvent.unlazy_statics

def self.InteractionAck; InteractionAck; end
##
# Wire protocol message for MCP to acknowledge InteractionEvent receipt.

class InteractionAck < ::Quark.mdk_protocol.Serializable
    attr_accessor :sequence
    extend ::DatawireQuarkCore::Static

    static _json_type: -> { "interactionack" }
    static mdk_metrics_InteractionAck_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def _getClass()
        
        return "mdk_metrics.InteractionAck"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_json_type"))
            return ::Quark.mdk_metrics.InteractionAck._json_type
        end
        if ((name) == ("sequence"))
            return (self).sequence
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_json_type"))
            ::Quark.mdk_metrics.InteractionAck._json_type = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("sequence"))
            (self).sequence = ::DatawireQuarkCore.cast(value) { ::Integer }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.sequence = nil

        nil
    end


end
InteractionAck.unlazy_statics

def self.MetricsClient; MetricsClient; end
##
# Mini-protocol for sending metrics to MCP.

class MetricsClient < ::DatawireQuarkCore::QuarkObject
    attr_accessor :_dispatcher, :_sock, :_sendWithAcks
    extend ::DatawireQuarkCore::Static

    static mdk_metrics_MetricsClient_ref: -> { nil }



    def initialize(wsclient)
        
        self.__init_fields__
        wsclient.subscribe(self)

        nil
    end




    ##
    # Queue info about interaction to be sent to the MCP.

    def sendInteraction(evt)
        
        (self)._sendWithAcks.send(::Quark.mdk_metrics.InteractionEvent._json_type, evt)

        nil
    end

    def onStart(dispatcher)
        
        (self)._dispatcher = dispatcher

        nil
    end

    def onStop()
        
        nil

        nil
    end

    def onMessage(origin, message)
        
        ::Quark.mdk_protocol._subscriberDispatch(self, message)

        nil
    end

    def onWSConnected(websock)
        
        (self)._sock = websock
        (self)._sendWithAcks.onConnected(::Quark.mdk_protocol.WSSend.new(self, (self)._dispatcher, (self)._sock))

        nil
    end

    def onPump()
        
        (self)._sendWithAcks.onPump(::Quark.mdk_protocol.WSSend.new(self, (self)._dispatcher, (self)._sock))

        nil
    end

    def onMessageFromServer(message)
        
        type = (::Quark.quark.reflect.QuarkClass.get(::DatawireQuarkCore._getClass(message))).id
        if ((type) == ("metrics.InteractionAck"))
            ack = ::DatawireQuarkCore.cast(message) { ::Quark.mdk_metrics.InteractionAck }
            (self)._sendWithAcks.onAck((ack).sequence)
            return
        end

        nil
    end

    def _getClass()
        
        return "mdk_metrics.MetricsClient"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_dispatcher"))
            return (self)._dispatcher
        end
        if ((name) == ("_sock"))
            return (self)._sock
        end
        if ((name) == ("_sendWithAcks"))
            return (self)._sendWithAcks
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_dispatcher"))
            (self)._dispatcher = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.MessageDispatcher }
        end
        if ((name) == ("_sock"))
            (self)._sock = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.Actor }
        end
        if ((name) == ("_sendWithAcks"))
            (self)._sendWithAcks = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.SendWithAcks }
        end

        nil
    end

    def __init_fields__()
        
        self._dispatcher = nil
        self._sock = nil
        self._sendWithAcks = ::Quark.mdk_protocol.SendWithAcks.new()

        nil
    end


end
MetricsClient.unlazy_statics


require_relative 'datawire_mdk_md' # 0 () ()

end # module MdkMetrics
end # module Quark
