# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_protocol; MdkProtocol; end
module MdkProtocol
require "datawire-quark-core"
require_relative 'quark/reflect' # 0 ('quark',) ()
require_relative 'quark' # 0 () ()
require_relative 'quark/concurrent' # 0 ('quark',) ()
require_relative 'mdk_runtime/actors' # 0 ('mdk_runtime',) ()
require_relative 'mdk_runtime' # 0 () ()
require_relative 'quark/error' # 0 ('quark',) ()


##
# Returns whether a list contains a given value.

def self.contains(values, value)
    
    idx = 0
    while ((idx) < ((values).size)) do
        if ((value) == ((values)[idx]))
            return true
        end
        idx = (idx) + (1)
    end
    return false


    nil
end

def self.Serializable; Serializable; end
##
# JSON serializable object.
#
# If it has have a String field called _json_type, that will be set as the
# 'type' field in serialized JSON.
#

class Serializable < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_Serializable_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Decode JSON into a particular class. XXX TURN INTO FUNCTION

    def self.decodeClassName(name, encoded)
        
        json = ::DatawireQuarkCore::JSONObject.parse(encoded)
        clazz = ::Quark.quark.reflect.QuarkClass.get(name)
        obj = ::DatawireQuarkCore.cast(clazz.construct(::DatawireQuarkCore::List.new([]))) { ::Quark.mdk_protocol.Serializable }
        if ((obj) == (nil))
            raise (((("could not construct ") + (clazz.getName())) + (" from this json: ")) + (encoded))
        end
        ::Quark.quark.fromJSON(clazz, obj, json)
        return obj

        nil
    end

    def encode()
        
        clazz = ::Quark.quark.reflect.QuarkClass.get(::DatawireQuarkCore._getClass(self))
        json = ::Quark.quark.toJSON(self, clazz)
        jsonType = ::DatawireQuarkCore.cast((self)._getField("_json_type")) { ::String }
        if ((jsonType) != (nil))
            (json).setObjectItem(("type"), (::DatawireQuarkCore::JSONObject.new.setString(jsonType)))
        end
        encoded = json.toString()
        return encoded

        nil
    end

    def _getClass()
        
        return "mdk_protocol.Serializable"

        nil
    end

    def _getField(name)
        
        return nil

        nil
    end

    def _setField(name, value)
        
        nil

        nil
    end

    def __init_fields__()
        

        nil
    end


end
Serializable.unlazy_statics

def self.LamportClock; LamportClock; end
##
# A Lamport Clock is a logical structure meant to allow partial causal ordering. Ours is a list of
# integers such that adding an integer implies adding a new level to the causality tree.
#
# Within a level, time is indicated by incrementing the clock, so
#
# [1,2,3] comes before [1,2,4] which comes before [1,2,5]
#
# Adding an element to the clock implies causality, so [1,2,4,1-N] is _by definition_ a sequence that was
# _caused by_ the sequence of [1,2,1-3].
#
# Note that LamportClock is lowish-level support. SharedContext puts some more structure around this, too.
#

class LamportClock < ::Quark.mdk_protocol.Serializable
    attr_accessor :_mutex, :clocks
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_LamportClock_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def self.decode(encoded)
        
        return ::DatawireQuarkCore.cast(::Quark.mdk_protocol.Serializable.decodeClassName("mdk_protocol.LamportClock", encoded)) { ::Quark.mdk_protocol.LamportClock }

        nil
    end

    ##
    # Return a neatly-formatted list of all of our clock elements (e.g. 1,2,4,1) for use as a name or
    # a key.
    #

    def key()
        
        @_mutex.acquire()
        tmp = ::DatawireQuarkCore::List.new([])
        i = 0
        while ((i) < (((self).clocks).size)) do
            (tmp) << ((((self).clocks)[i]).to_s)
            i = (i) + (1)
        end
        str = (tmp).join(",")
        @_mutex.release()
        return str

        nil
    end

    def toString()
        
        @_mutex.acquire()
        str = (("<LamportClock ") + (self.key())) + (">")
        @_mutex.release()
        return str

        nil
    end

    ##
    # Enter a new level of causality. Returns the value to pass to later pass to leave to get back to the
    # current level of causality.
    #

    def enter()
        
        @_mutex.acquire()
        current = -(1)
        ((self).clocks) << (0)
        current = ((self).clocks).size
        @_mutex.release()
        return current

        nil
    end

    ##
    # Leave deeper levels of causality. popTo should be the value returned when you enter()d this level.
    #

    def leave(popTo)
        
        @_mutex.acquire()
        current = -(1)
        (self).clocks = ::Quark.quark.ListUtil.new().slice((self).clocks, 0, popTo)
        current = ((self).clocks).size
        @_mutex.release()
        return current

        nil
    end

    ##
    # Increment the clock for our current level of causality (which is always the last element in the list).
    # If there are no elements in our clock, do nothing.
    #

    def tick()
        
        @_mutex.acquire()
        current = ((self).clocks).size
        if ((current) > (0))
            ((self).clocks)[(current) - (1)] = ((((self).clocks)[(current) - (1)]) + (1))
        end
        @_mutex.release()

        nil
    end

    def _getClass()
        
        return "mdk_protocol.LamportClock"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_mutex"))
            return (self)._mutex
        end
        if ((name) == ("clocks"))
            return (self).clocks
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_mutex"))
            (self)._mutex = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::Lock }
        end
        if ((name) == ("clocks"))
            (self).clocks = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end

        nil
    end

    def __init_fields__()
        
        super
        self._mutex = ::DatawireQuarkCore::Lock.new()
        self.clocks = ::DatawireQuarkCore::List.new([])

        nil
    end


end
LamportClock.unlazy_statics

def self.OperationalEnvironment; OperationalEnvironment; end
##
# An isolated environment with a name, and optionally a fallback environment.
#
# By default the environment will be 'sandbox'.
#

class OperationalEnvironment < ::Quark.mdk_protocol.Serializable
    attr_accessor :name, :fallbackName
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_OperationalEnvironment_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    ##
    # Return the fallback Environment, or null if there isn't one.

    def getFallback()
        
        if (((self).fallbackName) == (nil))
            return ::DatawireQuarkCore.cast(nil) { ::Quark.mdk_protocol.OperationalEnvironment }
        end
        result = ::Quark.mdk_protocol.OperationalEnvironment.new()
        (result).name = (self).fallbackName
        (result).fallbackName = ::DatawireQuarkCore.cast(nil) { ::String }
        return result

        nil
    end

    def _getClass()
        
        return "mdk_protocol.OperationalEnvironment"

        nil
    end

    def _getField(name)
        
        if ((name) == ("name"))
            return (self).name
        end
        if ((name) == ("fallbackName"))
            return (self).fallbackName
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("name"))
            (self).name = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("fallbackName"))
            (self).fallbackName = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.name = "sandbox"
        self.fallbackName = nil

        nil
    end


end
OperationalEnvironment.unlazy_statics

def self.SharedContext; SharedContext; end
class SharedContext < ::Quark.mdk_protocol.Serializable
    attr_accessor :traceId, :clock, :properties, :environment, :_lastEntry
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_SharedContext_ref: -> { nil }



    def initialize()
        
        super()
        (self)._lastEntry = (self).clock.enter()

        nil
    end




    ##
    # Set the traceId for this SharedContext.

    def withTraceId(traceId)
        
        (self).traceId = traceId
        return self

        nil
    end

    def self.decode(encoded)
        
        return ::DatawireQuarkCore.cast(::Quark.mdk_protocol.Serializable.decodeClassName("mdk_protocol.SharedContext", encoded)) { ::Quark.mdk_protocol.SharedContext }

        nil
    end

    def clockStr(pfx)
        
        cs = ""
        if (((self).clock) != (nil))
            cs = (pfx) + ((self).clock.key())
        end
        return cs

        nil
    end

    def key()
        
        return ((self).traceId) + (self.clockStr(":"))

        nil
    end

    def toString()
        
        return ((("<SCTX t:") + ((self).traceId)) + (self.clockStr(" c:"))) + (">")

        nil
    end

    ##
    # Tick the clock at our current causality level.
    #

    def tick()
        
        (self).clock.tick()

        nil
    end

    ##
    # Return a SharedContext one level deeper in causality.
    #
    # NOTE WELL: THIS RETURNS A NEW SharedContext RATHER THAN MODIFYING THIS ONE. It is NOT SUPPORTED
    # to modify the causality level of a SharedContext in place.
    #

    def start_span()
        
        self.tick()
        newContext = ::Quark.mdk_protocol.SharedContext.decode(self.encode())
        (newContext)._lastEntry = (newContext).clock.enter()
        return newContext

        nil
    end

    ##
    # Return a SharedContext one level higher in causality. In practice, most callers should probably stop
    # using this context, and the new one, after calling this method.
    #
    # NOTE WELL: THIS RETURNS A NEW SharedContext RATHER THAN MODIFYING THIS ONE. It is NOT SUPPORTED
    # to modify the causality level of a SharedContext in place.
    #

    def finish_span()
        
        newContext = ::Quark.mdk_protocol.SharedContext.decode(self.encode())
        (newContext)._lastEntry = (newContext).clock.leave((newContext)._lastEntry)
        return newContext

        nil
    end

    ##
    # Return a copy of a SharedContext.

    def copy()
        
        return ::Quark.mdk_protocol.SharedContext.decode(self.encode())

        nil
    end

    def _getClass()
        
        return "mdk_protocol.SharedContext"

        nil
    end

    def _getField(name)
        
        if ((name) == ("traceId"))
            return (self).traceId
        end
        if ((name) == ("clock"))
            return (self).clock
        end
        if ((name) == ("properties"))
            return (self).properties
        end
        if ((name) == ("environment"))
            return (self).environment
        end
        if ((name) == ("_lastEntry"))
            return (self)._lastEntry
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("traceId"))
            (self).traceId = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("clock"))
            (self).clock = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.LamportClock }
        end
        if ((name) == ("properties"))
            (self).properties = ::DatawireQuarkCore.cast(value) { ::Hash }
        end
        if ((name) == ("environment"))
            (self).environment = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.OperationalEnvironment }
        end
        if ((name) == ("_lastEntry"))
            (self)._lastEntry = ::DatawireQuarkCore.cast(value) { ::Integer }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.traceId = ::Quark.quark.concurrent.Context.runtime().uuid()
        self.clock = ::Quark.mdk_protocol.LamportClock.new()
        self.properties = {}
        self.environment = ::Quark.mdk_protocol.OperationalEnvironment.new()
        self._lastEntry = 0

        nil
    end


end
SharedContext.unlazy_statics

def self.Open; Open; end
##
# A message sent whenever a new connection is opened, by both sides.

class Open < ::Quark.mdk_protocol.Serializable
    attr_accessor :version, :mdkVersion, :properties, :nodeId, :environment
    extend ::DatawireQuarkCore::Static

    static _json_type: -> { "open" }
    static mdk_protocol_Open_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def _getClass()
        
        return "mdk_protocol.Open"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_json_type"))
            return ::Quark.mdk_protocol.Open._json_type
        end
        if ((name) == ("version"))
            return (self).version
        end
        if ((name) == ("mdkVersion"))
            return (self).mdkVersion
        end
        if ((name) == ("properties"))
            return (self).properties
        end
        if ((name) == ("nodeId"))
            return (self).nodeId
        end
        if ((name) == ("environment"))
            return (self).environment
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_json_type"))
            ::Quark.mdk_protocol.Open._json_type = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("version"))
            (self).version = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("mdkVersion"))
            (self).mdkVersion = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("properties"))
            (self).properties = ::DatawireQuarkCore.cast(value) { ::Hash }
        end
        if ((name) == ("nodeId"))
            (self).nodeId = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("environment"))
            (self).environment = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.OperationalEnvironment }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.version = "2.0.0"
        self.mdkVersion = ""
        self.properties = {}
        self.nodeId = nil
        self.environment = ::Quark.mdk_protocol.OperationalEnvironment.new()

        nil
    end


end
Open.unlazy_statics

def self.ProtocolError; ProtocolError; end
##
# A value class for sending error informationto a remote peer.

class ProtocolError < ::DatawireQuarkCore::QuarkObject
    attr_accessor :code, :title, :detail, :id
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_ProtocolError_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    def toString()
        
        return ((((((("ID:") + (@id)) + (" code:")) + (@code)) + (" ")) + (@title)) + ("\n")) + (@detail)

        nil
    end

    def _getClass()
        
        return "mdk_protocol.ProtocolError"

        nil
    end

    def _getField(name)
        
        if ((name) == ("code"))
            return (self).code
        end
        if ((name) == ("title"))
            return (self).title
        end
        if ((name) == ("detail"))
            return (self).detail
        end
        if ((name) == ("id"))
            return (self).id
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("code"))
            (self).code = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("title"))
            (self).title = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("detail"))
            (self).detail = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("id"))
            (self).id = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        self.code = nil
        self.title = nil
        self.detail = nil
        self.id = nil

        nil
    end


end
ProtocolError.unlazy_statics

def self.Close; Close; end
##
# Close the event stream.

class Close < ::Quark.mdk_protocol.Serializable
    attr_accessor :error
    extend ::DatawireQuarkCore::Static

    static _json_type: -> { "close" }
    static mdk_protocol_Close_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def _getClass()
        
        return "mdk_protocol.Close"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_json_type"))
            return ::Quark.mdk_protocol.Close._json_type
        end
        if ((name) == ("error"))
            return (self).error
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_json_type"))
            ::Quark.mdk_protocol.Close._json_type = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("error"))
            (self).error = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.ProtocolError }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.error = nil

        nil
    end


end
Close.unlazy_statics

def self.Pump; Pump; end
##
# Sent to a subscriber every once in a while, to tell subscribers they can send data.

class Pump < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_Pump_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    def _getClass()
        
        return "mdk_protocol.Pump"

        nil
    end

    def _getField(name)
        
        return nil

        nil
    end

    def _setField(name, value)
        
        nil

        nil
    end

    def __init_fields__()
        

        nil
    end


end
Pump.unlazy_statics

def self.WSConnected; WSConnected; end
##
# Sent to a subscriber when connection happens.

class WSConnected < ::DatawireQuarkCore::QuarkObject
    attr_accessor :websock
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_WSConnected_ref: -> { nil }



    def initialize(websock)
        
        self.__init_fields__
        (self).websock = websock

        nil
    end




    def _getClass()
        
        return "mdk_protocol.WSConnected"

        nil
    end

    def _getField(name)
        
        if ((name) == ("websock"))
            return (self).websock
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("websock"))
            (self).websock = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.Actor }
        end

        nil
    end

    def __init_fields__()
        
        self.websock = nil

        nil
    end


end
WSConnected.unlazy_statics

def self.DecodedMessage; DecodedMessage; end
##
# Sent to a subscriber when a message is received.

class DecodedMessage < ::DatawireQuarkCore::QuarkObject
    attr_accessor :message
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_DecodedMessage_ref: -> { nil }



    def initialize(message)
        
        self.__init_fields__
        (self).message = message

        nil
    end




    def _getClass()
        
        return "mdk_protocol.DecodedMessage"

        nil
    end

    def _getField(name)
        
        if ((name) == ("message"))
            return (self).message
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("message"))
            (self).message = value
        end

        nil
    end

    def __init_fields__()
        
        self.message = nil

        nil
    end


end
DecodedMessage.unlazy_statics

def self.WSClientSubscriber; WSClientSubscriber; end
##
# Higher-level interface for subscribers, to be utilized with _subscriberDispatch.

class WSClientSubscriber < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_WSClientSubscriber_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Handle an incoming decoded JSON message received from the server.

    def onMessageFromServer(message)
        raise NotImplementedError, '`WSClientSubscriber.onMessageFromServer` is an abstract method'

        nil
    end

    ##
    # Called with WebSocket actor when the WSClient connects to the server.

    def onWSConnected(websocket)
        raise NotImplementedError, '`WSClientSubscriber.onWSConnected` is an abstract method'

        nil
    end

    ##
    # Called when the WSClient notifies the subscriber it can send data.

    def onPump()
        raise NotImplementedError, '`WSClientSubscriber.onPump` is an abstract method'

        nil
    end

    def __init_fields__()
        

        nil
    end


end
WSClientSubscriber.unlazy_statics

##
# Dispatch actor messages to a WSClientSubscriber.
#
# Call this in onMessage to handle DecodedMessage, WSConnected and Pump messages
# from the WSClient.
#

def self._subscriberDispatch(subscriber, message)
    
    klass = (::Quark.quark.reflect.QuarkClass.get(::DatawireQuarkCore._getClass(message))).id
    if ((klass) == ("mdk_protocol.WSConnected"))
        connected = ::DatawireQuarkCore.cast(message) { ::Quark.mdk_protocol.WSConnected }
        subscriber.onWSConnected((connected).websock)
        return
    end
    if ((klass) == ("mdk_protocol.Pump"))
        subscriber.onPump()
        return
    end
    if ((klass) == ("mdk_protocol.DecodedMessage"))
        decoded = ::DatawireQuarkCore.cast(message) { ::Quark.mdk_protocol.DecodedMessage }
        subscriber.onMessageFromServer((decoded).message)
        return
    end


    nil
end

def self.OpenCloseSubscriber; OpenCloseSubscriber; end
##
# Handle Open and Close messages.

class OpenCloseSubscriber < ::DatawireQuarkCore::QuarkObject
    attr_accessor :_dispatcher, :_wsclient, :_node_id, :_environment
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_OpenCloseSubscriber_ref: -> { nil }



    def initialize(client, node_id, environment)
        
        self.__init_fields__
        (self)._wsclient = client
        (self)._node_id = node_id
        (self)._environment = environment
        (self)._wsclient.subscribe(self)

        nil
    end




    def onStart(dispatcher)
        
        (self)._dispatcher = dispatcher

        nil
    end

    def onMessage(origin, message)
        
        ::Quark.mdk_protocol._subscriberDispatch(self, message)

        nil
    end

    def onStop()
        
        nil

        nil
    end

    def onMessageFromServer(message)
        
        type = (::Quark.quark.reflect.QuarkClass.get(::DatawireQuarkCore._getClass(message))).id
        if ((type) == ("mdk_protocol.Open"))
            self.onOpen()
            return
        end
        if ((type) == ("mdk_protocol.Close"))
            close = ::DatawireQuarkCore.cast(message) { ::Quark.mdk_protocol.Close }
            self.onClose(close)
            return
        end

        nil
    end

    def onWSConnected(websocket)
        
        open = ::Quark.mdk_protocol.Open.new()
        (open).mdkVersion = "2.0.37"
        (open).nodeId = (self)._node_id
        (open).environment = @_environment
        (self)._dispatcher.tell(self, open.encode(), websocket)

        nil
    end

    def onPump()
        
        nil

        nil
    end

    def onOpen()
        
        nil

        nil
    end

    def onClose(close)
        
        (self)._wsclient.onClose((close).error)

        nil
    end

    def _getClass()
        
        return "mdk_protocol.OpenCloseSubscriber"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_dispatcher"))
            return (self)._dispatcher
        end
        if ((name) == ("_wsclient"))
            return (self)._wsclient
        end
        if ((name) == ("_node_id"))
            return (self)._node_id
        end
        if ((name) == ("_environment"))
            return (self)._environment
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_dispatcher"))
            (self)._dispatcher = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.MessageDispatcher }
        end
        if ((name) == ("_wsclient"))
            (self)._wsclient = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.WSClient }
        end
        if ((name) == ("_node_id"))
            (self)._node_id = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("_environment"))
            (self)._environment = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.OperationalEnvironment }
        end

        nil
    end

    def __init_fields__()
        
        self._dispatcher = nil
        self._wsclient = nil
        self._node_id = nil
        self._environment = nil

        nil
    end


end
OpenCloseSubscriber.unlazy_statics

def self.JSONParser; JSONParser; end
##
# Convert JSON-encoded strings into objects.

class JSONParser < ::DatawireQuarkCore::QuarkObject
    attr_accessor :_typeToClass
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_JSONParser_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Register a type field and the corresponding class.

    def register(type, cls)
        
        ((self)._typeToClass)[type] = (cls)

        nil
    end

    ##
    # Decode a String into an Object.

    def decode(message)
        
        json = ::DatawireQuarkCore::JSONObject.parse(message)
        cls = ((self)._typeToClass)[json.getObjectItem("type").getString()]
        if ((cls) == (nil))
            return nil
        end
        instance = cls.construct(::DatawireQuarkCore::List.new([]))
        ::Quark.quark.fromJSON(cls, instance, json)
        return instance

        nil
    end

    def _getClass()
        
        return "mdk_protocol.JSONParser"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_typeToClass"))
            return (self)._typeToClass
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_typeToClass"))
            (self)._typeToClass = ::DatawireQuarkCore.cast(value) { ::Hash }
        end

        nil
    end

    def __init_fields__()
        
        self._typeToClass = {}

        nil
    end


end
JSONParser.unlazy_statics

def self.WSClient; WSClient; end
##
# Common protocol machinery for web socket based protocol clients.

class WSClient < ::DatawireQuarkCore::QuarkObject
    attr_accessor :logger, :firstDelay, :maxDelay, :reconnectDelay, :ttl, :tick, :sock, :lastConnectAttempt, :timeService, :schedulingActor, :websockets, :dispatcher, :url, :token, :subscribers, :_started, :_parser
    extend ::DatawireQuarkCore::Static

    static quark_List_mdk_runtime_actors_Actor__ref: -> { nil }
    static mdk_protocol_WSClient_ref: -> { nil }



    def initialize(runtime, parser, url, token)
        
        self.__init_fields__
        (self).dispatcher = (runtime).dispatcher
        (self).timeService = runtime.getTimeService()
        (self).schedulingActor = runtime.getScheduleService()
        (self).websockets = runtime.getWebSocketsService()
        (self).url = url
        (self).token = token
        (self)._parser = parser

        nil
    end




    ##
    # Subscribe to messages from the server.
    #
    # Do this before starting the WSClient.
    #
    # The given Actor subscribes to WSConnected, all WSMessage received by the
    # WSClient, as well as a periodic Pump message.
    #

    def subscribe(subscriber)
        
        ((self).subscribers) << (subscriber)

        nil
    end

    def isStarted()
        
        return @_started

        nil
    end

    def isConnected()
        
        return (@sock) != (nil)

        nil
    end

    def schedule(time)
        
        (self).dispatcher.tell(self, ::Quark.mdk_runtime.Schedule.new("wakeup", time), (self).schedulingActor)

        nil
    end

    def scheduleReconnect()
        
        self.schedule(@reconnectDelay)

        nil
    end

    ##
    # Called when the connection is closed via message by the server.

    def onClose(error)
        
        if ((error) != (nil))
            @logger.error(("Server closing connection due to error: ") + (error.toString()))
        end

        nil
    end

    def doBackoff()
        
        @reconnectDelay = (2.0) * (@reconnectDelay)
        if ((@reconnectDelay) > (@maxDelay))
            @reconnectDelay = @maxDelay
        end
        @logger.info((("backing off, reconnecting in ") + ((@reconnectDelay).to_s)) + (" seconds"))

        nil
    end

    def onStart(dispatcher)
        
        (self)._started = true
        self.schedule(0.0)

        nil
    end

    def onStop()
        
        (self)._started = false
        if (self.isConnected())
            (self).dispatcher.tell(self, ::Quark.mdk_runtime.WSClose.new(), @sock)
            @sock = ::DatawireQuarkCore.cast(nil) { ::Quark.mdk_runtime.WSActor }
        end

        nil
    end

    def onMessage(origin, message)
        
        typeId = (::Quark.quark.reflect.QuarkClass.get(::DatawireQuarkCore._getClass(message))).id
        if ((typeId) == ("mdk_runtime.Happening"))
            self.onScheduledEvent()
            return
        end
        if ((typeId) == ("mdk_runtime.WSClosed"))
            self.onWSClosed()
            return
        end
        if ((typeId) == ("mdk_runtime.WSMessage"))
            wsmessage = ::DatawireQuarkCore.cast(message) { ::Quark.mdk_runtime.WSMessage }
            parsed = (self)._parser.decode((wsmessage).body)
            if ((parsed) == (nil))
                return
            end
            decoded = ::Quark.mdk_protocol.DecodedMessage.new(parsed)
            idx = 0
            while ((idx) < (((self).subscribers).size)) do
                (self).dispatcher.tell(self, decoded, ((self).subscribers)[idx])
                idx = (idx) + (1)
            end
            return
        end

        nil
    end

    def onScheduledEvent()
        
        rightNow = (((self).timeService.time()) * (1000.0)).round()
        reconnectInterval = ((@reconnectDelay) * (1000.0)).round()
        if (self.isConnected())
            if (self.isStarted())
                self.pump()
            end
        else
            if ((self.isStarted()) && (((rightNow) - (@lastConnectAttempt)) >= (reconnectInterval)))
                self.doOpen()
            end
        end
        if (self.isStarted())
            self.schedule(@tick)
        end

        nil
    end

    def doOpen()
        
        @lastConnectAttempt = (((self).timeService.time()) * (1000.0)).round()
        sockUrl = @url
        if ((@token) != (nil))
            sockUrl = ((sockUrl) + ("?token=")) + (@token)
        end
        @logger.info(("opening ") + (@url))
        (self).websockets.connect(sockUrl, self).andEither(::Quark.quark._BoundMethod.new(self, "onWSConnected", ::DatawireQuarkCore::List.new([])), ::Quark.quark._BoundMethod.new(self, "onWSError", ::DatawireQuarkCore::List.new([])))

        nil
    end

    def startup()
        
        message = ::Quark.mdk_protocol.WSConnected.new((self).sock)
        idx = 0
        while ((idx) < ((@subscribers).size)) do
            (self).dispatcher.tell(self, message, (@subscribers)[idx])
            idx = (idx) + (1)
        end

        nil
    end

    def pump()
        
        message = ::Quark.mdk_protocol.Pump.new()
        idx = 0
        while ((idx) < ((@subscribers).size)) do
            (self).dispatcher.tell(self, message, (@subscribers)[idx])
            idx = (idx) + (1)
        end

        nil
    end

    def onWSConnected(socket)
        
        @logger.info(((("connected to ") + (@url)) + (" via ")) + ((socket).to_s))
        @reconnectDelay = @firstDelay
        @sock = socket
        self.startup()
        self.pump()

        nil
    end

    def onWSError(error)
        
        @logger.error(("onWSError in protocol! ") + (error.toString()))
        self.doBackoff()

        nil
    end

    def onWSClosed()
        
        @logger.info(("closed ") + (@url))
        @sock = ::DatawireQuarkCore.cast(nil) { ::Quark.mdk_runtime.WSActor }

        nil
    end

    def _getClass()
        
        return "mdk_protocol.WSClient"

        nil
    end

    def _getField(name)
        
        if ((name) == ("logger"))
            return (self).logger
        end
        if ((name) == ("firstDelay"))
            return (self).firstDelay
        end
        if ((name) == ("maxDelay"))
            return (self).maxDelay
        end
        if ((name) == ("reconnectDelay"))
            return (self).reconnectDelay
        end
        if ((name) == ("ttl"))
            return (self).ttl
        end
        if ((name) == ("tick"))
            return (self).tick
        end
        if ((name) == ("sock"))
            return (self).sock
        end
        if ((name) == ("lastConnectAttempt"))
            return (self).lastConnectAttempt
        end
        if ((name) == ("timeService"))
            return (self).timeService
        end
        if ((name) == ("schedulingActor"))
            return (self).schedulingActor
        end
        if ((name) == ("websockets"))
            return (self).websockets
        end
        if ((name) == ("dispatcher"))
            return (self).dispatcher
        end
        if ((name) == ("url"))
            return (self).url
        end
        if ((name) == ("token"))
            return (self).token
        end
        if ((name) == ("subscribers"))
            return (self).subscribers
        end
        if ((name) == ("_started"))
            return (self)._started
        end
        if ((name) == ("_parser"))
            return (self)._parser
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("logger"))
            (self).logger = value
        end
        if ((name) == ("firstDelay"))
            (self).firstDelay = ::DatawireQuarkCore.cast(value) { ::Float }
        end
        if ((name) == ("maxDelay"))
            (self).maxDelay = ::DatawireQuarkCore.cast(value) { ::Float }
        end
        if ((name) == ("reconnectDelay"))
            (self).reconnectDelay = ::DatawireQuarkCore.cast(value) { ::Float }
        end
        if ((name) == ("ttl"))
            (self).ttl = ::DatawireQuarkCore.cast(value) { ::Float }
        end
        if ((name) == ("tick"))
            (self).tick = ::DatawireQuarkCore.cast(value) { ::Float }
        end
        if ((name) == ("sock"))
            (self).sock = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.WSActor }
        end
        if ((name) == ("lastConnectAttempt"))
            (self).lastConnectAttempt = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("timeService"))
            (self).timeService = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.Time }
        end
        if ((name) == ("schedulingActor"))
            (self).schedulingActor = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.Actor }
        end
        if ((name) == ("websockets"))
            (self).websockets = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.WebSockets }
        end
        if ((name) == ("dispatcher"))
            (self).dispatcher = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.MessageDispatcher }
        end
        if ((name) == ("url"))
            (self).url = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("token"))
            (self).token = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("subscribers"))
            (self).subscribers = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end
        if ((name) == ("_started"))
            (self)._started = ::DatawireQuarkCore.cast(value) { ::Object }
        end
        if ((name) == ("_parser"))
            (self)._parser = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.JSONParser }
        end

        nil
    end

    def __init_fields__()
        
        self.logger = ::Quark.quark._getLogger("protocol")
        self.firstDelay = 1.0
        self.maxDelay = 16.0
        self.reconnectDelay = @firstDelay
        self.ttl = 30.0
        self.tick = 1.0
        self.sock = nil
        self.lastConnectAttempt = 0
        self.timeService = nil
        self.schedulingActor = nil
        self.websockets = nil
        self.dispatcher = nil
        self.url = nil
        self.token = nil
        self.subscribers = ::DatawireQuarkCore::List.new([])
        self._started = false
        self._parser = nil

        nil
    end


end
WSClient.unlazy_statics

def self.AckablePayload; AckablePayload; end
##
# The payload for an ackable event.

class AckablePayload < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_AckablePayload_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # When did this happen? Milliseconds since Unix epoch.

    def getTimestamp()
        raise NotImplementedError, '`AckablePayload.getTimestamp` is an abstract method'

        nil
    end

    def __init_fields__()
        

        nil
    end


end
AckablePayload.unlazy_statics

def self.AckableEvent; AckableEvent; end
##
# An event that can be acknowledged.

class AckableEvent < ::DatawireQuarkCore::QuarkObject
    attr_accessor :json_type, :sequence, :sync, :payload
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_AckableEvent_ref: -> { nil }



    def initialize(json_type, payload, sequence)
        
        self.__init_fields__
        (self).json_type = json_type
        (self).payload = payload
        (self).sequence = sequence

        nil
    end




    def getTimestamp()
        
        return @payload.getTimestamp()

        nil
    end

    def encode()
        
        clazz = ::Quark.quark.reflect.QuarkClass.get(::DatawireQuarkCore._getClass((self).payload))
        json = ::Quark.quark.toJSON((self).payload, clazz)
        (json).setObjectItem(("type"), (::DatawireQuarkCore::JSONObject.new.setString((self).json_type)))
        (json).setObjectItem(("sequence"), (::DatawireQuarkCore::JSONObject.new.setNumber((self).sequence)))
        (json).setObjectItem(("sync"), (::DatawireQuarkCore::JSONObject.new.setNumber((self).sync)))
        encoded = json.toString()
        return encoded

        nil
    end

    def _getClass()
        
        return "mdk_protocol.AckableEvent"

        nil
    end

    def _getField(name)
        
        if ((name) == ("json_type"))
            return (self).json_type
        end
        if ((name) == ("sequence"))
            return (self).sequence
        end
        if ((name) == ("sync"))
            return (self).sync
        end
        if ((name) == ("payload"))
            return (self).payload
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("json_type"))
            (self).json_type = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("sequence"))
            (self).sequence = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("sync"))
            (self).sync = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("payload"))
            (self).payload = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.AckablePayload }
        end

        nil
    end

    def __init_fields__()
        
        self.json_type = nil
        self.sequence = nil
        self.sync = 1
        self.payload = nil

        nil
    end


end
AckableEvent.unlazy_statics

def self.SendAckableEvent; SendAckableEvent; end
##
# Send a message to the other side.

class SendAckableEvent < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_SendAckableEvent_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    def send(event)
        raise NotImplementedError, '`SendAckableEvent.send` is an abstract method'

        nil
    end

    def __init_fields__()
        

        nil
    end


end
SendAckableEvent.unlazy_statics

def self.WSSend; WSSend; end
##
# Send using a WebSocket actor.

class WSSend < ::DatawireQuarkCore::QuarkObject
    attr_accessor :origin, :dispatcher, :sock
    extend ::DatawireQuarkCore::Static

    static mdk_protocol_WSSend_ref: -> { nil }



    def initialize(origin, dispatcher, sock)
        
        self.__init_fields__
        (self).origin = origin
        (self).dispatcher = dispatcher
        (self).sock = sock

        nil
    end




    def send(event)
        
        @dispatcher.tell(@origin, event.encode(), @sock)

        nil
    end

    def toString()
        
        return ((self).sock).to_s

        nil
    end

    def _getClass()
        
        return "mdk_protocol.WSSend"

        nil
    end

    def _getField(name)
        
        if ((name) == ("origin"))
            return (self).origin
        end
        if ((name) == ("dispatcher"))
            return (self).dispatcher
        end
        if ((name) == ("sock"))
            return (self).sock
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("origin"))
            (self).origin = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.Actor }
        end
        if ((name) == ("dispatcher"))
            (self).dispatcher = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.MessageDispatcher }
        end
        if ((name) == ("sock"))
            (self).sock = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.Actor }
        end

        nil
    end

    def __init_fields__()
        
        self.origin = nil
        self.dispatcher = nil
        self.sock = nil

        nil
    end


end
WSSend.unlazy_statics

def self.SendWithAcks; SendWithAcks; end
##
# Utility class for sending messages with a protocol that sends back acks.
#

class SendWithAcks < ::DatawireQuarkCore::QuarkObject
    attr_accessor :_buffered, :_inFlight, :_added, :_sent, :_recorded, :_myLog
    extend ::DatawireQuarkCore::Static

    static quark_Map_quark_long_mdk_protocol_AckableEvent__ref: -> { nil }
    static mdk_protocol_SendWithAcks_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    def _debug(message)
        
        s = (((("[") + (((::DatawireQuarkCore::List.new((@_buffered).keys)).size).to_s)) + (" buf, ")) + (((::DatawireQuarkCore::List.new((@_inFlight).keys)).size).to_s)) + (" inf] ")
        @_myLog.debug((s) + (message))

        nil
    end

    ##
    # Call when (re)connected to other side.

    def onConnected(sender)
        
        (@_buffered).merge!(@_inFlight)
        @_inFlight = {}
        self.onPump(sender)

        nil
    end

    ##
    # Call to send buffered messages.

    def onPump(sender)
        
        seqs = ::DatawireQuarkCore::List.new((@_buffered).keys)
        (seqs).sort!
        idx = 0
        while (((seqs).size) > (idx)) do
            evt = (@_buffered).delete((seqs)[idx])
            (@_inFlight)[(evt).sequence] = (evt)
            sender.send(evt)
            idx = (idx) + (1)
        end

        nil
    end

    ##
    # Called when receiving acknowledgement from other side.

    def onAck(sequence)
        
        (@_inFlight).delete(sequence)
        @_recorded = (@_recorded) + ((1))
        self._debug(((("ack #") + ((sequence).to_s)) + (", discarding #")) + ((sequence).to_s))

        nil
    end

    ##
    # Send an event.

    def send(json_type, event)
        
        wrapper = ::Quark.mdk_protocol.AckableEvent.new(json_type, event, @_added)
        @_added = (@_added) + ((1))
        (@_buffered)[(wrapper).sequence] = (wrapper)
        self._debug(("logged #") + (((wrapper).sequence).to_s))

        nil
    end

    def _getClass()
        
        return "mdk_protocol.SendWithAcks"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_buffered"))
            return (self)._buffered
        end
        if ((name) == ("_inFlight"))
            return (self)._inFlight
        end
        if ((name) == ("_added"))
            return (self)._added
        end
        if ((name) == ("_sent"))
            return (self)._sent
        end
        if ((name) == ("_recorded"))
            return (self)._recorded
        end
        if ((name) == ("_myLog"))
            return (self)._myLog
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_buffered"))
            (self)._buffered = ::DatawireQuarkCore.cast(value) { ::Hash }
        end
        if ((name) == ("_inFlight"))
            (self)._inFlight = ::DatawireQuarkCore.cast(value) { ::Hash }
        end
        if ((name) == ("_added"))
            (self)._added = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("_sent"))
            (self)._sent = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("_recorded"))
            (self)._recorded = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("_myLog"))
            (self)._myLog = value
        end

        nil
    end

    def __init_fields__()
        
        self._buffered = {}
        self._inFlight = {}
        self._added = 0
        self._sent = 0
        self._recorded = 0
        self._myLog = ::Quark.quark._getLogger("SendWithAcks")

        nil
    end


end
SendWithAcks.unlazy_statics


require_relative 'datawire_mdk_md' # 0 () ()

end # module MdkProtocol
end # module Quark
