# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_runtime; MdkRuntime; end
module MdkRuntime
def self.files; Files; end
module Files
require "datawire-quark-core"
require_relative '../quark/reflect' # 0 ('quark',) ('mdk_runtime',)
require_relative 'actors' # 1 () ()
require_relative '../mdk_runtime' # 0 () ('mdk_runtime',)


def self.SubscribeChanges; SubscribeChanges; end
##
# Message to FileActor asking to be notified of files' changing contents and
# deletions for the given directory or file path.
#

class SubscribeChanges < ::DatawireQuarkCore::QuarkObject
    attr_accessor :path
    extend ::DatawireQuarkCore::Static

    static mdk_runtime_files_SubscribeChanges_ref: -> { nil }



    def initialize(path)
        
        self.__init_fields__
        (self).path = path

        nil
    end




    def _getClass()
        
        return "mdk_runtime.files.SubscribeChanges"

        nil
    end

    def _getField(name)
        
        if ((name) == ("path"))
            return (self).path
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("path"))
            (self).path = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        self.path = nil

        nil
    end


end
SubscribeChanges.unlazy_statics

def self.FileContents; FileContents; end
##
# Message from FileActor with contents of a file.

class FileContents < ::DatawireQuarkCore::QuarkObject
    attr_accessor :path, :contents
    extend ::DatawireQuarkCore::Static

    static mdk_runtime_files_FileContents_ref: -> { nil }



    def initialize(path, contents)
        
        self.__init_fields__
        (self).path = path
        (self).contents = contents

        nil
    end




    def _getClass()
        
        return "mdk_runtime.files.FileContents"

        nil
    end

    def _getField(name)
        
        if ((name) == ("path"))
            return (self).path
        end
        if ((name) == ("contents"))
            return (self).contents
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("path"))
            (self).path = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("contents"))
            (self).contents = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        self.path = nil
        self.contents = nil

        nil
    end


end
FileContents.unlazy_statics

def self.FileDeleted; FileDeleted; end
##
# Message from FileActor indicating a file was deleted.

class FileDeleted < ::DatawireQuarkCore::QuarkObject
    attr_accessor :path
    extend ::DatawireQuarkCore::Static

    static mdk_runtime_files_FileDeleted_ref: -> { nil }



    def initialize(path)
        
        self.__init_fields__
        (self).path = path

        nil
    end




    def _getClass()
        
        return "mdk_runtime.files.FileDeleted"

        nil
    end

    def _getField(name)
        
        if ((name) == ("path"))
            return (self).path
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("path"))
            (self).path = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        self.path = nil

        nil
    end


end
FileDeleted.unlazy_statics

def self.FileActor; FileActor; end
##
# File interactions.
#
# Accepts:
# - SubscribeChanges messages, which result in FileContents and FiledDeleted
# messages being sent to original subscriber.
#

class FileActor < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_runtime_files_FileActor_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Create a temporary directory and return its path.

    def mktempdir()
        raise NotImplementedError, '`FileActor.mktempdir` is an abstract method'

        nil
    end

    ##
    # Write a file with UTF-8 encoded text.

    def write(path, contents)
        raise NotImplementedError, '`FileActor.write` is an abstract method'

        nil
    end

    ##
    # Delete a file.

    def delete(path)
        raise NotImplementedError, '`FileActor.delete` is an abstract method'

        nil
    end

    def _getClass()
        
        return "mdk_runtime.files.FileActor"

        nil
    end

    def _getField(name)
        
        return nil

        nil
    end

    def _setField(name, value)
        
        nil

        nil
    end

    ##
    # The Actor should begin shutting down.

    def onStop()
        
        nil

        nil
    end

    def __init_fields__()
        

        nil
    end


end
FileActor.unlazy_statics

def self.FileActorImpl; FileActorImpl; end
##
# Polling-based subscriptions.
#
# Should switch to inotify later on.
#
# Shim over native implementations. Need better way to do this.
#

class FileActorImpl < ::Quark.mdk_runtime.files.FileActor
    attr_accessor :scheduling, :dispatcher, :subscriptions, :stopped
    extend ::DatawireQuarkCore::Static

    static quark_List_mdk_runtime_files__Subscription__ref: -> { nil }
    static mdk_runtime_files_FileActorImpl_ref: -> { nil }



    def initialize(runtime)
        
        super()
        (self).scheduling = runtime.getScheduleService()

        nil
    end




    def mktempdir()
        
        return ""

        nil
    end

    def write(path, contents)
        
        false

        nil
    end

    def delete(path)
        
        false

        nil
    end

    def _checkSubscriptions()
        
        if ((self).stopped)
            return
        end
        (self).dispatcher.tell(self, ::Quark.mdk_runtime.Schedule.new("poll", 1.0), (self).scheduling)
        idx = 0
        while ((idx) < (((self).subscriptions).size)) do
            ((self).subscriptions)[idx].poll()
            idx = (idx) + (1)
        end

        nil
    end

    def onStart(dispatcher)
        
        (self).dispatcher = dispatcher
        self._checkSubscriptions()

        nil
    end

    def onStop()
        
        (self).stopped = true

        nil
    end

    def onMessage(origin, message)
        
        typeId = (::Quark.quark.reflect.QuarkClass.get(::DatawireQuarkCore._getClass(message))).id
        if ((typeId) == ("mdk_runtime.Happening"))
            self._checkSubscriptions()
            return
        end
        if ((typeId) == ("mdk_runtime.files.SubscribeChanges"))
            subscribe = ::DatawireQuarkCore.cast(message) { ::Quark.mdk_runtime.files.SubscribeChanges }
            ((self).subscriptions) << (::Quark.mdk_runtime.files._Subscription.new(self, origin, (subscribe).path))
            return
        end

        nil
    end

    def _send(message, destination)
        
        (self).dispatcher.tell(self, message, destination)

        nil
    end

    def _getClass()
        
        return "mdk_runtime.files.FileActorImpl"

        nil
    end

    def _getField(name)
        
        if ((name) == ("scheduling"))
            return (self).scheduling
        end
        if ((name) == ("dispatcher"))
            return (self).dispatcher
        end
        if ((name) == ("subscriptions"))
            return (self).subscriptions
        end
        if ((name) == ("stopped"))
            return (self).stopped
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("scheduling"))
            (self).scheduling = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.Actor }
        end
        if ((name) == ("dispatcher"))
            (self).dispatcher = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.MessageDispatcher }
        end
        if ((name) == ("subscriptions"))
            (self).subscriptions = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end
        if ((name) == ("stopped"))
            (self).stopped = ::DatawireQuarkCore.cast(value) { ::Object }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.scheduling = nil
        self.dispatcher = nil
        self.subscriptions = ::DatawireQuarkCore::List.new([])
        self.stopped = false

        nil
    end


end
FileActorImpl.unlazy_statics

def self._Subscription; Subscription; end
##
# A specific file notification subscription.

class Subscription < ::DatawireQuarkCore::QuarkObject
    attr_accessor :path, :actor, :subscriber, :previous_listing
    extend ::DatawireQuarkCore::Static

    static mdk_runtime_files__Subscription_ref: -> { nil }



    def initialize(actor, subscriber, path)
        
        self.__init_fields__
        (self).subscriber = subscriber
        (self).actor = actor
        (self).path = path

        nil
    end




    def poll()
        
        new_listing = []
        idx = 0
        while ((idx) < ((new_listing).size)) do
            (self).actor._send(::Quark.mdk_runtime.files.FileContents.new((new_listing)[idx], ""), (self).subscriber)
            idx = (idx) + (1)
        end
        idx = 0
        jdx = nil
        found = nil
        while ((idx) < ((@previous_listing).size)) do
            jdx = 0
            found = false
            while ((jdx) < ((new_listing).size)) do
                if (((@previous_listing)[idx]) == ((new_listing)[jdx]))
                    found = true
                    break
                end
                jdx = (jdx) + (1)
            end
            if (!(found))
                (self).actor._send(::Quark.mdk_runtime.files.FileDeleted.new((@previous_listing)[idx]), (self).subscriber)
            end
            idx = (idx) + (1)
        end
        (self).previous_listing = new_listing

        nil
    end

    def _getClass()
        
        return "mdk_runtime.files._Subscription"

        nil
    end

    def _getField(name)
        
        if ((name) == ("path"))
            return (self).path
        end
        if ((name) == ("actor"))
            return (self).actor
        end
        if ((name) == ("subscriber"))
            return (self).subscriber
        end
        if ((name) == ("previous_listing"))
            return (self).previous_listing
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("path"))
            (self).path = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("actor"))
            (self).actor = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.files.FileActorImpl }
        end
        if ((name) == ("subscriber"))
            (self).subscriber = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.Actor }
        end
        if ((name) == ("previous_listing"))
            (self).previous_listing = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end

        nil
    end

    def __init_fields__()
        
        self.path = nil
        self.actor = nil
        self.subscriber = nil
        self.previous_listing = ::DatawireQuarkCore::List.new([])

        nil
    end


end
Subscription.unlazy_statics


require_relative '../datawire_mdk_md' # 0 () ('mdk_runtime',)

end # module Files
end # module MdkRuntime
end # module Quark
