# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_tracing; MdkTracing; end
module MdkTracing
require "datawire-quark-core"
require_relative 'quark/reflect' # 0 ('quark',) ()
require_relative 'mdk_tracing/api' # 0 ('mdk_tracing',) ()
require_relative 'mdk_tracing/protocol' # 0 ('mdk_tracing',) ()
require_relative 'mdk_runtime/actors' # 0 ('mdk_runtime',) ()
require_relative 'mdk_protocol' # 0 () ()
require_relative 'quark' # 0 () ()
require_relative 'mdk_runtime' # 0 () ()
require_relative 'mdk_rtp' # 0 () ()


def self.TracingDestination; TracingDestination; end
##
# MDK can use this to handle logging on the Session.

class TracingDestination < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_tracing_TracingDestination_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Send a log message to the server. Call using logToTracer().

    def log(event)
        raise NotImplementedError, '`TracingDestination.log` is an abstract method'

        nil
    end

    def __init_fields__()
        

        nil
    end


end
TracingDestination.unlazy_statics

##
# Construct a LogEvent and write to a tracer.

def self.createLogEvent(ctx, procUUID, level, category, text)
    
    ctx.tick()
    evt = ::Quark.mdk_tracing.protocol.LogEvent.new()
    (evt).context = ctx.copy()
    (evt).timestamp = ::Quark.quark.now()
    (evt).node = procUUID
    (evt).level = level
    (evt).category = category
    (evt).contentType = "text/plain"
    (evt).text = text
    return evt


    nil
end

def self.FakeTracer; FakeTracer; end
##
# In-memory testing of logs.

class FakeTracer < ::DatawireQuarkCore::QuarkObject
    attr_accessor :messages
    extend ::DatawireQuarkCore::Static

    static mdk_tracing_FakeTracer_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    def log(event)
        
        (@messages) << ({"level" => (event).level, "category" => (event).category, "text" => (event).text, "context" => ((event).context).traceId})

        nil
    end

    def onStart(dispatcher)
        
        nil

        nil
    end

    def onStop()
        
        nil

        nil
    end

    def onMessage(origin, message)
        
        nil

        nil
    end

    def _getClass()
        
        return "mdk_tracing.FakeTracer"

        nil
    end

    def _getField(name)
        
        if ((name) == ("messages"))
            return (self).messages
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("messages"))
            (self).messages = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end

        nil
    end

    def __init_fields__()
        
        self.messages = ::DatawireQuarkCore::List.new([])

        nil
    end


end
FakeTracer.unlazy_statics

def self.Tracer; Tracer; end
##
# Send log messages to the MCP server.

class Tracer < ::DatawireQuarkCore::QuarkObject
    attr_accessor :logger, :lastPoll, :_client, :runtime
    extend ::DatawireQuarkCore::Static

    static mdk_tracing_Tracer_ref: -> { nil }



    def initialize(runtime, wsclient)
        
        self.__init_fields__
        (self).runtime = runtime
        (self)._client = ::Quark.mdk_tracing.protocol.TracingClient.new(self, wsclient)

        nil
    end




    ##
    # Backwards compatibility.

    def self.withURLsAndToken(url, queryURL, token)
        
        return ::Quark.mdk_tracing.Tracer.withURLAndToken(url, token)

        nil
    end

    def self.withURLAndToken(url, token)
        
        runtime = ::Quark.mdk_runtime.defaultRuntime()
        wsclient = ::Quark.mdk_protocol.WSClient.new(runtime, ::Quark.mdk_rtp.getRTPParser(), url, token)
        (runtime).dispatcher.startActor(wsclient)
        newTracer = ::Quark.mdk_tracing.Tracer.new(runtime, wsclient)
        (runtime).dispatcher.startActor(newTracer)
        return newTracer

        nil
    end

    def onStart(dispatcher)
        
        dispatcher.startActor(@_client)

        nil
    end

    def onStop()
        
        (@runtime).dispatcher.stopActor(@_client)

        nil
    end

    def onMessage(origin, mesage)
        
        nil

        nil
    end

    ##
    # Send a log message to the server.

    def log(event)
        
        @logger.trace(("CTX ") + ((event).context.toString()))
        @_client.log(event)

        nil
    end

    def subscribe(handler)
        
        @_client.subscribe(handler)

        nil
    end

    def _getClass()
        
        return "mdk_tracing.Tracer"

        nil
    end

    def _getField(name)
        
        if ((name) == ("logger"))
            return (self).logger
        end
        if ((name) == ("lastPoll"))
            return (self).lastPoll
        end
        if ((name) == ("_client"))
            return (self)._client
        end
        if ((name) == ("runtime"))
            return (self).runtime
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("logger"))
            (self).logger = value
        end
        if ((name) == ("lastPoll"))
            (self).lastPoll = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("_client"))
            (self)._client = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_tracing.protocol.TracingClient }
        end
        if ((name) == ("runtime"))
            (self).runtime = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.MDKRuntime }
        end

        nil
    end

    def __init_fields__()
        
        self.logger = ::Quark.quark._getLogger("MDK Tracer")
        self.lastPoll = 0
        self._client = nil
        self.runtime = nil

        nil
    end


end
Tracer.unlazy_statics


require_relative 'datawire_mdk_md' # 0 () ()

end # module MdkTracing
end # module Quark
