# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_tracing; MdkTracing; end
module MdkTracing
def self.protocol; Protocol; end
module Protocol
require "datawire-quark-core"
require_relative '../quark/reflect' # 0 ('quark',) ('mdk_tracing',)
require_relative '../mdk_protocol' # 0 () ('mdk_tracing',)
require_relative '../mdk_tracing' # 0 () ('mdk_tracing',)
require_relative '../quark' # 0 () ('mdk_tracing',)
require_relative '../mdk_runtime/actors' # 0 ('mdk_runtime',) ('mdk_tracing',)


def self.LogEvent; LogEvent; end
class LogEvent < ::Quark.mdk_protocol.Serializable
    attr_accessor :context, :timestamp, :node, :level, :category, :contentType, :text
    extend ::DatawireQuarkCore::Static

    static _json_type: -> { "log" }
    static mdk_tracing_protocol_LogEvent_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def getTimestamp()
        
        return (self).timestamp

        nil
    end

    def toString()
        
        return (((((((((((((("<LogEvent ") + ((@timestamp).to_s)) + (" ")) + (@context.toString())) + (", ")) + (@node)) + (", ")) + (@level)) + (", ")) + (@category)) + (", ")) + (@contentType)) + (", ")) + (@text)) + (">")

        nil
    end

    def _getClass()
        
        return "mdk_tracing.protocol.LogEvent"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_json_type"))
            return ::Quark.mdk_tracing.protocol.LogEvent._json_type
        end
        if ((name) == ("context"))
            return (self).context
        end
        if ((name) == ("timestamp"))
            return (self).timestamp
        end
        if ((name) == ("node"))
            return (self).node
        end
        if ((name) == ("level"))
            return (self).level
        end
        if ((name) == ("category"))
            return (self).category
        end
        if ((name) == ("contentType"))
            return (self).contentType
        end
        if ((name) == ("text"))
            return (self).text
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_json_type"))
            ::Quark.mdk_tracing.protocol.LogEvent._json_type = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("context"))
            (self).context = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.SharedContext }
        end
        if ((name) == ("timestamp"))
            (self).timestamp = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("node"))
            (self).node = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("level"))
            (self).level = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("category"))
            (self).category = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("contentType"))
            (self).contentType = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("text"))
            (self).text = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.context = nil
        self.timestamp = nil
        self.node = nil
        self.level = nil
        self.category = nil
        self.contentType = nil
        self.text = nil

        nil
    end


end
LogEvent.unlazy_statics

def self.Subscribe; Subscribe; end
class Subscribe < ::Quark.mdk_protocol.Serializable
    extend ::DatawireQuarkCore::Static

    static _json_type: -> { "subscribe" }
    static mdk_tracing_protocol_Subscribe_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def toString()
        
        return "<Subscribe>"

        nil
    end

    def _getClass()
        
        return "mdk_tracing.protocol.Subscribe"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_json_type"))
            return ::Quark.mdk_tracing.protocol.Subscribe._json_type
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_json_type"))
            ::Quark.mdk_tracing.protocol.Subscribe._json_type = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        super

        nil
    end


end
Subscribe.unlazy_statics

def self.LogAck; LogAck; end
class LogAck < ::Quark.mdk_protocol.Serializable
    attr_accessor :sequence
    extend ::DatawireQuarkCore::Static

    static _json_type: -> { "logack" }
    static mdk_tracing_protocol_LogAck_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def toString()
        
        return (("<LogAck ") + ((@sequence).to_s)) + (">")

        nil
    end

    def _getClass()
        
        return "mdk_tracing.protocol.LogAck"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_json_type"))
            return ::Quark.mdk_tracing.protocol.LogAck._json_type
        end
        if ((name) == ("sequence"))
            return (self).sequence
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_json_type"))
            ::Quark.mdk_tracing.protocol.LogAck._json_type = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("sequence"))
            (self).sequence = ::DatawireQuarkCore.cast(value) { ::Integer }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.sequence = nil

        nil
    end


end
LogAck.unlazy_statics

def self.TracingClient; TracingClient; end
class TracingClient < ::DatawireQuarkCore::QuarkObject
    attr_accessor :_tracer, :_started, :_mutex, :_handler, :_dispatcher, :_wsclient, :_sock, :_sendWithAcks
    extend ::DatawireQuarkCore::Static

    static mdk_tracing_protocol_TracingClient_ref: -> { nil }



    def initialize(tracer, wsclient)
        
        self.__init_fields__
        @_tracer = tracer
        @_wsclient = wsclient
        @_sendWithAcks = ::Quark.mdk_protocol.SendWithAcks.new()
        wsclient.subscribe(self)

        nil
    end




    ##
    # Attach a subscriber that will receive results of queries.

    def subscribe(handler)
        
        @_mutex.acquire()
        @_handler = handler
        @_mutex.release()

        nil
    end

    def onStart(dispatcher)
        
        (self)._dispatcher = dispatcher

        nil
    end

    def onStop()
        
        nil

        nil
    end

    def onMessage(origin, message)
        
        ::Quark.mdk_protocol._subscriberDispatch(self, message)

        nil
    end

    def onWSConnected(websock)
        
        @_mutex.acquire()
        (self)._sock = websock
        if ((@_handler) != (nil))
            (self)._dispatcher.tell(self, ::Quark.mdk_tracing.protocol.Subscribe.new().encode(), (self)._sock)
        end
        (self)._sendWithAcks.onConnected(::Quark.mdk_protocol.WSSend.new(self, (self)._dispatcher, (self)._sock))
        @_mutex.release()

        nil
    end

    def onPump()
        
        @_mutex.acquire()
        (self)._sendWithAcks.onPump(::Quark.mdk_protocol.WSSend.new(self, (self)._dispatcher, (self)._sock))
        @_mutex.release()

        nil
    end

    def onMessageFromServer(message)
        
        type = (::Quark.quark.reflect.QuarkClass.get(::DatawireQuarkCore._getClass(message))).id
        if ((type) == ("mdk_tracing.protocol.LogEvent"))
            event = ::DatawireQuarkCore.cast(message) { ::Quark.mdk_tracing.protocol.LogEvent }
            self.onLogEvent(event)
            return
        end
        if ((type) == ("mdk_tracing.protocol.LogAck"))
            ack = ::DatawireQuarkCore.cast(message) { ::Quark.mdk_tracing.protocol.LogAck }
            self.onLogAck(ack)
            return
        end

        nil
    end

    def onLogEvent(evt)
        
        @_mutex.acquire()
        if ((@_handler) != (nil))
            (@_handler).call(evt)
        end
        @_mutex.release()

        nil
    end

    def onLogAck(ack)
        
        @_mutex.acquire()
        (self)._sendWithAcks.onAck((ack).sequence)
        @_mutex.release()

        nil
    end

    ##
    # Queue a log message for delivery to the server.

    def log(evt)
        
        @_mutex.acquire()
        (self)._sendWithAcks.send(::Quark.mdk_tracing.protocol.LogEvent._json_type, evt)
        @_mutex.release()

        nil
    end

    def _getClass()
        
        return "mdk_tracing.protocol.TracingClient"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_tracer"))
            return (self)._tracer
        end
        if ((name) == ("_started"))
            return (self)._started
        end
        if ((name) == ("_mutex"))
            return (self)._mutex
        end
        if ((name) == ("_handler"))
            return (self)._handler
        end
        if ((name) == ("_dispatcher"))
            return (self)._dispatcher
        end
        if ((name) == ("_wsclient"))
            return (self)._wsclient
        end
        if ((name) == ("_sock"))
            return (self)._sock
        end
        if ((name) == ("_sendWithAcks"))
            return (self)._sendWithAcks
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_tracer"))
            (self)._tracer = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_tracing.Tracer }
        end
        if ((name) == ("_started"))
            (self)._started = ::DatawireQuarkCore.cast(value) { ::Object }
        end
        if ((name) == ("_mutex"))
            (self)._mutex = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::Lock }
        end
        if ((name) == ("_handler"))
            (self)._handler = ::DatawireQuarkCore.cast(value) { ::Quark.quark.UnaryCallable }
        end
        if ((name) == ("_dispatcher"))
            (self)._dispatcher = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.MessageDispatcher }
        end
        if ((name) == ("_wsclient"))
            (self)._wsclient = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.WSClient }
        end
        if ((name) == ("_sock"))
            (self)._sock = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.actors.Actor }
        end
        if ((name) == ("_sendWithAcks"))
            (self)._sendWithAcks = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_protocol.SendWithAcks }
        end

        nil
    end

    def __init_fields__()
        
        self._tracer = nil
        self._started = false
        self._mutex = ::DatawireQuarkCore::Lock.new()
        self._handler = nil
        self._dispatcher = nil
        self._wsclient = nil
        self._sock = nil
        self._sendWithAcks = nil

        nil
    end


end
TracingClient.unlazy_statics


require_relative '../datawire_mdk_md' # 0 () ('mdk_tracing',)

end # module Protocol
end # module MdkTracing
end # module Quark
