# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
def self.quark; Quark; end
module Quark
def self.logging; Logging; end
module Logging
require "datawire-quark-core"
require_relative 'reflect' # 1 () ()


def self.Appender; Appender; end
##
# Destination for logging

class Appender < ::DatawireQuarkCore::QuarkObject
    attr_accessor :name
    extend ::DatawireQuarkCore::Static

    static quark_logging_Appender_ref: -> { nil }



    def initialize(name)
        
        self.__init_fields__
        (self).name = name

        nil
    end




    def _getClass()
        
        return "quark.logging.Appender"

        nil
    end

    def _getField(name)
        
        if ((name) == ("name"))
            return (self).name
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("name"))
            (self).name = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        self.name = nil

        nil
    end


end
Appender.unlazy_statics

##
# Logging appender that sends log messages to standard output

def self.stdout()
    
    return ::Quark.quark.logging.Appender.new(":STDOUT")


    nil
end

##
# Logging appender that sends log messages to standard error

def self.stderr()
    
    return ::Quark.quark.logging.Appender.new(":STDERR")


    nil
end

##
# Logging appender that sends log messages to a file

def self.file(path)
    
    return ::Quark.quark.logging.Appender.new(path)


    nil
end

##
# Set an environment variable to override logging set up in the code

def self.setEnvironmentOverride(envVar, level)
    
    ::Quark.quark.logging.Config._overrideEnvVar = envVar
    ::Quark.quark.logging.Config._overrideLevel = level


    nil
end

def self.Config; Config; end
##
# Logging configurator

class Config < ::DatawireQuarkCore::QuarkObject
    attr_accessor :appender, :level
    extend ::DatawireQuarkCore::Static

    static _overrideEnvVar: -> { "QUARK_TRACE" }
    static _overrideLevel: -> { "DEBUG" }
    static _configured: -> { false }
    static quark_logging_Config_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Set the destination for logging, default stderr()

    def setAppender(appender)
        
        (self).appender = appender
        return self

        nil
    end

    ##
    # set the logging level [trace|debug|info|warn|error], default 'info'

    def setLevel(level)
        
        (self).level = level
        return self

        nil
    end

    def self._getOverrideIfExists()
        
        if ((::Quark.quark.logging.Config._overrideEnvVar) == (nil))
            return ::DatawireQuarkCore.cast(nil) { ::String }
        end
        envVarValue = ENV[::Quark.quark.logging.Config._overrideEnvVar]
        if (((((envVarValue) == (nil)) || ((envVarValue) == (""))) || ((envVarValue) == ("0"))) || (((envVarValue).downcase) == ("false")))
            return ::DatawireQuarkCore.cast(nil) { ::String }
        end
        return envVarValue

        nil
    end

    def self._autoconfig()
        
        return (!(::Quark.quark.logging.Config._configured)) && ((::Quark.quark.logging.Config._getOverrideIfExists()) != (nil))

        nil
    end

    ##
    # Configure the logging

    def configure()
        
        envVarValue = ::Quark.quark.logging.Config._getOverrideIfExists()
        if ((envVarValue) != (nil))
            if (((envVarValue) == ("1")) || (((envVarValue).downcase) == ("true")))
                @appender = ::Quark.quark.logging.stderr()
            else
                @appender = ::Quark.quark.logging.file(envVarValue)
            end
            @level = ::Quark.quark.logging.Config._overrideLevel
        end
        ::DatawireQuarkCore.configureLogging((@appender), (@level))
        ::Quark.quark.logging.Config._configured = true

        nil
    end

    def _getClass()
        
        return "quark.logging.Config"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_overrideEnvVar"))
            return ::Quark.quark.logging.Config._overrideEnvVar
        end
        if ((name) == ("_overrideLevel"))
            return ::Quark.quark.logging.Config._overrideLevel
        end
        if ((name) == ("_configured"))
            return ::Quark.quark.logging.Config._configured
        end
        if ((name) == ("appender"))
            return (self).appender
        end
        if ((name) == ("level"))
            return (self).level
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_overrideEnvVar"))
            ::Quark.quark.logging.Config._overrideEnvVar = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("_overrideLevel"))
            ::Quark.quark.logging.Config._overrideLevel = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("_configured"))
            ::Quark.quark.logging.Config._configured = ::DatawireQuarkCore.cast(value) { ::Object }
        end
        if ((name) == ("appender"))
            (self).appender = ::DatawireQuarkCore.cast(value) { ::Quark.quark.logging.Appender }
        end
        if ((name) == ("level"))
            (self).level = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        self.appender = ::Quark.quark.logging.stderr()
        self.level = "INFO"

        nil
    end


end
Config.unlazy_statics

##
# Create a logging configurator

def self.makeConfig()
    
    return ::Quark.quark.logging.Config.new()


    nil
end


require_relative '../datawire_mdk_md' # 0 () ('quark',)

end # module Logging
end # module Quark
end # module Quark
